/* Message class, to load the language properties
 * author: Martin Schneider
 * created: 10.10.2010
 */

package atosj;

import java.io.File;
import java.util.MissingResourceException;
import java.util.ResourceBundle;
import atosj.app.UserPreferences;

public class Messages {
	/*default Language: de */
	private static String BUNDLE_NAME = "atosj.de"; //$NON-NLS-1$

	private static ResourceBundle RESOURCE_BUNDLE = ResourceBundle
			.getBundle(BUNDLE_NAME);
	
	private static boolean loaded = false;
	
	private static String pref_path = "." + File.separator + "user.prf";

	private Messages() {	
	}
	
	/**
	 * Setzen des Pfades zu 'user.prf'
	 * @param path
	 */
	public static void setPrefPath(String path){
		// nur setzen wenn nderung
		if (path != pref_path)
			pref_path = path;
	}
	
	public static String getString(String key) {
		//check the language setting and load the correct properties file or the default
		if(!loaded){
			UserPreferences.getInstance().setFilePath(pref_path);
			try{
				String tmp = (String) UserPreferences.getInstance().getPreferedValue(UserPreferences.LANGUAGE);
				BUNDLE_NAME ="atosj." +  tmp;
				RESOURCE_BUNDLE = ResourceBundle.getBundle(BUNDLE_NAME);
			}
			catch(MissingResourceException e){
				if(BUNDLE_NAME.equals("atosj.")){
					BUNDLE_NAME = "atosj.de";
					System.out.println(BUNDLE_NAME + "." + key);
				}
				//language properties couldn't be loaded!
			}
			loaded = true;
		}
		
		try {
			return RESOURCE_BUNDLE.getString(key);
		} catch (MissingResourceException e) {
			return '!' + key + '!';
		}
	}
}
