package atosj.action;

import org.eclipse.jface.action.Action;

import atosj.gui.TreeEntry;

/**
 * Eine Aktion die auf einem Element des Navigator-Baumes ausgefhrt werden kann. 
 * @author Nicos Tegos
 */
public abstract class TreeEntryAction extends Action 
{
	private TreeEntry entry;
	
	/**
	 * @param name Name der Aktion, wie er in der GUI angezeigt wird.
	 * @param entry Der Knoten im Baum.
	 */
	public TreeEntryAction(String name, TreeEntry entry) {
		super(name);
		this.entry = entry;
	}
	
	/**
	 * Gibt den assozierten Knoten des Baumes zurck.
	 */
	public TreeEntry getTreeEntry() {
		return entry;
	}
}