package atosj.action.help;

import java.io.IOException;

import org.eclipse.jface.action.Action;
import org.eclipse.jface.dialogs.MessageDialog;

import atosj.Messages;
import atosj.app.UserPreferences;

/**
 * ffnet den PDF-Reader fr das Handbuch.
 * @author Nicos Tegos
 */
public class HelpAction extends Action 
{
	public HelpAction() {
		super(Messages.getString("HelpAction.0")); //$NON-NLS-1$
	}
	
	/**
	 * Zeigt das Handbuch an. Der PDF-Reader muss in den Projekteinstellungen
	 * gesetzt sein.
	 */
	public void run() 
	{
		String pdfReader = (String) UserPreferences.getInstance().getPreferedValue(UserPreferences.PDF_READER_PATH);
		if(pdfReader != null)
		{
			try {
				Runtime.getRuntime().exec(pdfReader + " \"handbuch.pdf\"" ); //$NON-NLS-1$
			} catch(IOException e) {
				MessageDialog.openError(null, Messages.getString("HelpAction.2"), Messages.getString("HelpAction.3")); //$NON-NLS-1$ //$NON-NLS-2$
			}
		}
		else
		{
			MessageDialog.openError(null, Messages.getString("HelpAction.4"), Messages.getString("HelpAction.5")); //$NON-NLS-1$ //$NON-NLS-2$
		}
	}
}
