/*
 * Created on 28.11.2005
 */
package atosj.action.pack;

import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.swt.widgets.Display;

import atosj.Messages;
import atosj.action.TreeEntryAction;
import atosj.app.AtosJApp;
import atosj.editors.pack.PackageTreeEntry;
import atosj.model.pack.HTSPackage;

/**
 * Lscht ein Paket aus dem Projekt.
 * @author Nicos Tegos
 */
public class DeletePackageAction extends TreeEntryAction 
{
	public static final String id = "DELTE_SCRIPT_ACTION"; //$NON-NLS-1$
	
	public DeletePackageAction(PackageTreeEntry entry) {
		super(Messages.getString("DeletePackageAction.1"), entry); //$NON-NLS-1$
		setId(id);
	}
	
	protected HTSPackage getPackage() {
		return (HTSPackage) getTreeEntry().getWrappedObject();
	}
	
	/**
	 * Lscht ein Paket aus dem Projekt. Zuvor wird ein Dialog zur
	 * Besttigung durch den Nutzer aufgerufen.
	 * @see atosj.app.Project#deletePackage(HTSPackage)
	 */
	public void run() 
	{
		MessageDialog questionDlg = new MessageDialog(
				Display.getCurrent().getActiveShell(), 
				Messages.getString("DeletePackageAction.2"),  //$NON-NLS-1$
				null, 
				Messages.getString("DeletePackageAction.3") + getPackage().getName()  //$NON-NLS-1$
				+ Messages.getString("DeletePackageAction.4"),  //$NON-NLS-1$
				MessageDialog.QUESTION, 
				new String[] {Messages.getString("DeletePackageAction.5"), Messages.getString("DeletePackageAction.6")},  //$NON-NLS-1$ //$NON-NLS-2$
				0); 
		
		if( questionDlg.open() == 1 ) // lschen abgelehnt
			return;
		
		
		// paket im projekt lschen
		if( AtosJApp.getInstance().getInput().deletePackage(getPackage()) )
		{
			// paket im baum lschen
			getTreeEntry().getParent().removeChild( getTreeEntry() );
		}
		else
		{
			MessageDialog.openInformation(null, Messages.getString("DeletePackageAction.7"), Messages.getString("DeletePackageAction.8") + getPackage().getName()  //$NON-NLS-1$ //$NON-NLS-2$
					+ Messages.getString("DeletePackageAction.9")); //$NON-NLS-1$
		}
	}
}
