/*
 * Created on 17.01.2006
 */
package atosj.action.pack;

import org.eclipse.jface.dialogs.MessageDialog;

import atosj.Messages;
import atosj.action.TreeEntryAction;
import atosj.app.AtosJApp;
import atosj.editors.pack.PackageTreeDir;
import atosj.exception.AtosJException;
import atosj.listener.ClipboardListener;
import atosj.model.pack.HTSPackage;
import atosj.util.Clipboard;

/**
 * Fgt die Kopie eines Testpakets aus der Zwischenablage dem Projekt hinzu.
 * @author Nicos Tegos
 */
public class PastePackageAction extends TreeEntryAction implements ClipboardListener 
{

	public PastePackageAction(PackageTreeDir entry) {
		super(Messages.getString("PastePackageAction.0"), entry); //$NON-NLS-1$
		
		setEnabled( Clipboard.getInstance().containsOnlyClass(HTSPackage.class) );
	}

	private PackageTreeDir getPackageDir() {
		return (PackageTreeDir) getTreeEntry();
	}
	
	/**
	 * Fgt die Kopie eines Testpakets aus der Zwischenablage dem Projekt hinzu.
	 * @see atosj.app.Project#copyPackage(HTSPackage)
	 * @see Clipboard
	 */
	public void run() {
		try
		{
			HTSPackage newPack = AtosJApp.getInstance().getInput().copyPackage( 
				(HTSPackage) Clipboard.getInstance().getElements().get(0) 
			);
			
			getPackageDir().addPackage(newPack);
		}
		catch (AtosJException e) {
			MessageDialog.openError(null, Messages.getString("PastePackageAction.1"), Messages.getString("PastePackageAction.2") //$NON-NLS-1$ //$NON-NLS-2$
					+ e.getMessage() );
		}
	}

	/* (non-Javadoc)
	 * @see atosj.listener.ClipboardListener#clipboardChanged(atosj.util.Clipboard)
	 */
	public void clipboardChanged(Clipboard clip) {
		setEnabled( clip.containsOnlyClass(HTSPackage.class) );		
	}
}
