package atosj.action.project;

import org.eclipse.jface.action.Action;
import org.eclipse.swt.widgets.Display;

import atosj.Messages;
import atosj.app.AtosJApp;
import atosj.dialog.ProjectDlg;
import atosj.listener.InputListener;

/**
 * Zeigt den Dialog zum Bearbeiten eines Projektes.
 * @author Nicos Tegos
 */
public class ChangeProjectAction extends Action implements InputListener
{
	public static final String ID = "CHANGE_PROJECT_ACTION"; //$NON-NLS-1$
	
	public ChangeProjectAction() {
		super(Messages.getString("ChangeProjectAction.1")); //$NON-NLS-1$
		setId(ID);
		setEnabled(false);
		AtosJApp.getInstance().addInputListener(this);
	}
	
	/**
	 * Zeigt den Dialog zum Bearbeiten eines Projektes.
	 * @see ProjectDlg
	 */
	public void run() {
		new ProjectDlg( Display.getDefault().getActiveShell(), AtosJApp.getInstance().getInput() ).open();
	}

	public void inputChanged(Object oldObj, Object newObj) {
		setEnabled(newObj != null);		
	}
}
