package atosj.action.project;

import org.eclipse.jface.action.Action;
import org.eclipse.swt.widgets.Display;

import atosj.Messages;
import atosj.app.AtosJApp;
import atosj.dialog.CoverageDlg;
import atosj.listener.InputListener;

/**
 * Zeigt den Dialog zur Einstellung der berdeckungsanalyse.
 * @author Nicos Tegos
 */
public class CoverageAction extends Action implements InputListener {

	public CoverageAction() {
		super(Messages.getString("CoverageAction.0")); //$NON-NLS-1$
		
		setEnabled(false);
		AtosJApp.getInstance().addInputListener(this);
	}

	/**
	 * Zeigt den Dialog zur Einstellung der berdeckungsanalyse.
	 * @see CoverageDlg
	 */
	public void run() {
		new CoverageDlg( Display.getDefault().getActiveShell() ).open();
	}

	public void inputChanged(Object oldObj, Object newObj) {
		setEnabled(newObj != null);
	}
}
