/*
 * Created on 20.11.2005
 */
package atosj.action.project;

import org.eclipse.jface.action.Action;
import org.eclipse.swt.widgets.Display;

import atosj.Messages;
import atosj.app.AtosJApp;
import atosj.dialog.ProjectDlg;

/**
 * Zeigt den Dialog zum Erstellen eines neuen Projektes.
 * @author Nicos Tegos
 */
public class NewProjectAction extends Action 
{
	public static final String ID = "NEWPROJECT_ACTION"; //$NON-NLS-1$

	public NewProjectAction() {
		super(Messages.getString("NewProjectAction.1")); //$NON-NLS-1$
		setId(ID);
	}
	
	/**
	 * Zeigt den Dialog zum Erstellen eines neuen Projektes. 
	 * Zuvor wird das aktuelle Projekt geschlossen.
	 * @see CloseProjectAction#closeProject()
	 */
	public void run() 
	{
		// aktuelles Projekt schliessen
		if( !CloseProjectAction.closeProject() )
			return;
		
		ProjectDlg dlg = new ProjectDlg( Display.getCurrent().getActiveShell() );
		if( dlg.open()== ProjectDlg.ID_OK )
			AtosJApp.getInstance().setInput( dlg.getProject() );
	}
}
