/*
 * Created on 17.01.2006
 */
package atosj.action.script;

import org.eclipse.jface.dialogs.MessageDialog;

import atosj.Messages;
import atosj.action.TreeEntryAction;
import atosj.app.AtosJApp;
import atosj.editors.script.ScriptTreeDir;
import atosj.exception.AtosJException;
import atosj.model.script.HTSScript;
import atosj.util.Clipboard;

/**
 * Fgt die Kopie einer Testsequenz aus der Zwischenablage dem Projekt hinzu.
 * @author Nicos Tegos
 */
public class PasteScriptAction extends TreeEntryAction {

	public PasteScriptAction(ScriptTreeDir entry) {
		super(Messages.getString("PasteScriptAction.0"), entry); //$NON-NLS-1$
		
		setEnabled( Clipboard.getInstance().containsOnlyClass(HTSScript.class) );	
	}

	private ScriptTreeDir getScriptDir() {
		return (ScriptTreeDir) getTreeEntry();
	}
	
	/**
	 * Fgt die Kopie einer Testsequenz aus der Zwischenablage dem Projekt hinzu.
	 * @see atosj.app.Project#copyScript(HTSScript)
	 * @see Clipboard
	 */
	public void run() {
		try
		{
			HTSScript newScript = AtosJApp.getInstance().getInput().copyScript( 
				(HTSScript) Clipboard.getInstance().getElements().get(0) 
			);
			
			getScriptDir().addScript(newScript);
		}
		catch (AtosJException e) {
			MessageDialog.openError(null, Messages.getString("PasteScriptAction.1"), Messages.getString("PasteScriptAction.2") //$NON-NLS-1$ //$NON-NLS-2$
					+ e.getMessage() );
		}
	}

	/* (non-Javadoc)
	 * @see atosj.listener.ClipboardListener#clipboardChanged(atosj.util.Clipboard)
	 */
	public void clipboardChanged(Clipboard clip) {
		setEnabled( clip.containsOnlyClass(HTSScript.class) );		
	}

}
