/*
 * Created on 28.04.2006
 */
package atosj.component;

import atosj.exception.ComponentException;

/**
 * Dieses Interface reprsentiert den HTS TYP COMBOBOX.
 * @author Nicos Tegos
 */
public interface ICombobox extends IEditbox
{
	/**
	 * Whlt den angegebenen Index aus der Liste der Combobox aus.
	 * @param index Der Index 0-basiert.
	 * @throws ComponentException wenn der Index nicht im gltigen Bereich liegt.
	 */
	void select(int index) throws ComponentException;
	
	/**
	 * Whlt den angegebenen Eintrag aus der Liste der ComboBox aus.
	 * @param text Der auszuwhlende Eintrag.
	 * @throws ComponentException wenn der Text nicht in der Liste der
	 * Combobox gefunden wurde.
	 */
	void select(String text) throws ComponentException;
	
	/**
	 * @return Die Anzahl der Eintrge in der Liste der Combobox.
	 */
	int getItemCount() throws ComponentException;
}
