package atosj.component;

import java.util.Vector;

/**
 * Alle CommandCreator, die die Klasse ListCommandCreatorHelper nutzen wollen,
 * mssen dieses Interface implementieren. Es formalisiert die Selektion
 * eines zusammengesetzten Components, dies muss nicht zwangslufig eine Liste
 * sein.
 * @author Nicos Tegos
 * @see atosj.component.ListCommandCreatorHelper
 */
public interface IListCommandCreator extends ICommandCreator {
	/**
	 * @return Die Liste der aktuell ausgewhlten Objekte z.B. Indices einer Liste.
	 */
	Object[] getSelection();
	
	/**
	 * @param selectionObject Das ausgewhlte element z.B. ein Index in einer Liste.
	 * @return Vector(String) Der Subelementpfad im HTSFormat, d.h. 
	 * Strings werden in Anfhrungzeichen eingeschlossen, Zahlen ohne Anfhrungszeichen.
	 */
	Vector convertSelectionObjectToPath(Object selectionObject);
}
