/*
 * Created on 28.04.2006
 */
package atosj.component;

import atosj.exception.ComponentException;

/**
 * Dieses Interface reprsentiert den HTS-Typ TABFOLDER.
 * @author Nicos Tegos
 */
public interface ITabFolder extends IComponent
{
	/**
	 * Whlt den Tab mit dem angegebenen Index aus.
	 * @param index Der Index, 0-basiert.
	 * @throws ComponentException wenn der Index nicht im gltigen Bereich liegt.
	 */
	void select(int index) throws ComponentException;
	
	/**
	 * Whlt den Tab mit dem angegebenen Titel aus.
	 * @param title Der auszuwhlende Eintrag.
	 * @throws ComponentException wenn der Titel nicht in gefunden wurde.
	 */
	void select(String title) throws ComponentException;
	
	/**
	 * @return Der Titel des aktuell ausgewhlten Tabs, leerer
	 * String wenn kein Tab ausgewhlt.
	 */
	String getText() throws ComponentException;
	
	/**
	 * Gibt den Titel des Tabs am angegebenen Index zurck.
	 * @param index Der Index des Tabs.
	 * @return Der Titel des Tabs bei <code>index</code>.
	 * @throws ComponentException wenn der Index ungltig ist.
	 */
	String getText(int index) throws ComponentException;
	
	/**
	 * @return Die Anzahl der Tabs.
	 */
	int getItemCount() throws ComponentException;
}
