/*
 * Created on 28.04.2006
 */
package atosj.component;

import atosj.exception.ComponentException;

/**
 * Dieses Interface reprsentiert ein eine Tabellenzelle, auf der
 * nach HTS Syntax Kommandos ausgefhrt werden knnen.
 * @author Nicos Tegos
 */
public interface ITableCell extends IComponent, ILabel
{
	/**
	 * Rckt die Zelle in der Tabelle in den sichtbaren Bereich.
	 * Aktiviert den Zelleneditor.
	 * Setzt den angegebenen Text.
	 * Schliet den Zelleneditor.
	 * @param text  Der Text.
	 * @throws ComponentException wenn die Zelle nicht editierbar ist.
	 */
	void setText(String text) throws ComponentException;
	
	/**
	 * Setzt den Zustand auf <code>check</code>, falls dieser Zustand nicht schon vorher
	 * so war.
	 * @param check wenn <code>true</code> Hckchen setzen, 
	 * wenn <code>false</code> Hckchen entfernen.
	 * @throws ComponentException wenn die Zelle keine Checkbox ist.
	 */
	void setChecked(boolean check) throws ComponentException;
	
	/**
	 * @return der Check-Zustand der Tabellenzelle.  
	 * @throws ComponentException wenn die Zelle keine Checkbox ist.
	 */
	boolean isChecked() throws ComponentException;
}
