/*
 * Created on 28.04.2006
 */
package atosj.component;

import atosj.exception.ComponentException;

/**
 * Dieses Interface reprsentiert ein einen Baumknoten, auf dem
 * nach HTS Syntax Kommandos ausgefhrt werden knnen.
 * Dieses Interface erweitert NICHT ILabel, denn um die Zelle
 * des Baumes zu bekommen muss man sowieso schon ihre Beschriftung
 * wissen, damit ist die Funktion getText hinfllig.
 * @author Nicos Tegos
*/
public interface ITreeCell extends IComponent
{
	/**
	 * Rckt die Zelle in der Tabelle in den sichtbaren Bereich.
	 * Aktiviert den Zelleneditor.
	 * Setzt den angegebenen Text.
	 * Schliet den Zelleneditor.
	 * @param text  Der Text.
	 * @throws ComponentException wenn die Zelle nicht editierbar ist.
	 */
	void setText(String text) throws ComponentException;
}
