/*
 * Created on 28.04.2006
 */
package atosj.component;

import atosj.exception.ComponentException;

/**
 * Dieses Interface reprsentiert den HTS-Typ WINDOW.
 * @author Nicos Tegos
 */
public interface IWindow extends IComponent
{
	/**
	 * Schliet das Fenster.
	 */
	void close() throws ComponentException;
	
	/**
	 * Maximiert das Fenster.
	 */
	void maximize() throws ComponentException;
	
	/**
	 * Minimiert das Fenster.
	 */
	void minimize() throws ComponentException;
	
	/**
	 * Normalisiert das Fenster, wenn es maximiert oder
	 * minimiert ist.
	 */
	void normalize() throws ComponentException;
	
	/**
	 * @return Der Titel dieses Fensters.
	 */
	String getText() throws ComponentException;
}
