/*
 * Created on 03.01.2006
 */
package atosj.component;

/**
 * Ermittelt die Klarnamen von graphischen Objekten.
 * @author Nicos Tegos
 */
public abstract class NamingStrategy 
{
	/**
	 * Gibt den Klarnamen des Components zurck, dieser hngt vom
	 * Typ des Components ab.
	 * @param component Das graph. Objekt dessen Name ermittelt werden soll.
	 * @return ein nicht leerer String, der den Klarnamen 
	 * des graph. Objektes enthlt.
	 */
	public abstract String getName(Object component);
	
	/**
	 * Gibt einen einheitliche Zeichenkette fr die Position und Gre eines
	 * Components zurck.
	 * Die letzte Mglichkeit zur Benamung ist die Position und Grsse des
	 * Elements in seinem Fenster. Diese Funktion garantiert eine einheitliche
	 * Nomenklatur.
	 * @return String Reprsentation der Position und Gre eines Components.
	 */
	public String boundsToName(int x, int y, int width, int height) {
		return "Pos [x=" + x + ", y=" + y + ", b=" + width + ", h=" + height + "]"; 
	}
}
