/*
 * Created on 09.04.2006
 */
package atosj.component.swing;

import java.awt.Component;
import java.awt.Container;

import javax.swing.AbstractButton;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JMenu;
import javax.swing.JSpinner;
import javax.swing.JTable;
import javax.swing.JTree;
import javax.swing.SwingUtilities;
import javax.swing.text.JTextComponent;

import atosj.component.ComponentFinder;
import atosj.component.CustomComponentResolver;
import atosj.model.recorder.IHTSCommandReceiver;

/**
 * Der <code>ComponentFinder</code> fr die Swing Architektur.
 * @author Nicos Tegos
 */
public class SwingComponentFinder extends ComponentFinder {

	/**
	 * Erstellt einen <code>SwingComponentFinder</code> mit einem <code>SwingComponentResolver</code>
	 * und einer <code>SwingNamingStrategy</code>.
	 */
	public SwingComponentFinder(SwingComponentResolver resolver, IHTSCommandReceiver receiver) {
		super( resolver, new SwingNamingStrategy(), receiver );
	}
	
	public Object[] getChildren(Object component) 
	{
		if(component instanceof Container)
		{
			if( (getResolver() instanceof CustomComponentResolver) 
					&& ((CustomComponentResolver)getResolver()).isCustomComponent(component) )
			{
				return null;
			}
			
			if(component instanceof JTextComponent
			 || component instanceof JLabel
			 || component instanceof JMenu
			 || component instanceof AbstractButton
			 || component instanceof JList
			 || component instanceof JTree
			 || component instanceof JTable
			 || component instanceof JComboBox
			 || component instanceof JSpinner)
				return null;
			
			return ((Container)component).getComponents();
		}

		return null;
	}

	public Object getWindow(Object component) {
		return SwingUtilities.getRoot( (Component)component );
	}
}
