package  atosj.component.swing;

import java.util.Vector;

import javax.swing.JLabel;

import atosj.component.ComponentId;
import atosj.component.ILabel;
import atosj.exception.ComponentException;
import atosj.exception.InvalidOperationException;
import atosj.model.hts.parser.HTSSyntax;
import atosj.model.recorder.IHTSCommandReceiver;

/**
 * Wrapperklasse fr alle von <code>javax.swing.JLabel</code> abgeleiteten Klassen.
 * @author Nicos Tegos
 */
public class SwingLabel extends SwingComponent implements ILabel
{
	protected class MLabelCommandCreator extends SwingCommandCreator {

		public MLabelCommandCreator(SwingLabel component, IHTSCommandReceiver receiver) {
			super(component, receiver);
		}
		
		public Vector getTestCommands() {
			Vector commands = super.getTestCommands();
			
			try {
				Vector values = new Vector(1);
				String txt = ((ILabel)getMComponent()).getText();
				values.add( '"' + txt + '"' );
				commands.add( createTestCommand(HTSSyntax.READ_TEXT, values, null) );
			} catch(ComponentException e){}
			
			try {
				Vector values = new Vector(1);
				float num = ((ILabel)getMComponent()).getNum();
				values.add("" + num);
				commands.add( createTestCommand(HTSSyntax.READ_NUM, values, null) );
			} catch(ComponentException e){}
			
			return commands;
		}
	}
	
    public SwingLabel(JLabel component, ComponentId id) {
        super(component, id);
    }

    private JLabel getLabelComponent() {
        return (JLabel) getAWTComponent();
    }
    
    public String getText() {
        return getLabelComponent().getText();
    }

	public float getNum() throws ComponentException {
		try {
			return Float.parseFloat( getText() );
		} catch(NumberFormatException e) {
			throw new InvalidOperationException(this, OP_GET_NUM, false);
		}
	}
}