/*
 * Created on 25.12.2005
 */
package atosj.component.swing;

import java.awt.event.ActionEvent;
import java.util.Vector;

import javax.swing.JRadioButton;

import atosj.component.ComponentId;
import atosj.component.ICommandCreator;
import atosj.component.IRadio;
import atosj.exception.ComponentException;
import atosj.model.hts.parser.HTSSyntax;
import atosj.model.recorder.IHTSCommandReceiver;

/**
 * Wrapper fr alle von <code>javax.swing.JRadioButton</code> abgeleiteten Klassen.
 * @author Nicos Tegos
 */
public class SwingRadioButton extends SwingButton implements IRadio
{
	/**
	 * Zeichnet das Drcken des Knopfes auf.
	 */
	protected class RadioButtonCommandCreator extends ButtonCommandCreator
	{
		public RadioButtonCommandCreator(SwingRadioButton button, IHTSCommandReceiver receiver) {
			super(button, receiver);
		}
		
		public Vector getTestCommands() {
			Vector commands = super.getTestCommands();
			
			try {
				Vector values = new Vector(1);
				boolean val = ((IRadio)getMComponent()).isChecked();
				values.add( val ? HTSSyntax.COMPARE_TRUE : HTSSyntax.COMPARE_FALSE );
				commands.add( createTestCommand(HTSSyntax.READ_CHECKSTATE, values, null) );
			} catch(ComponentException e){}
			
			return commands;
		}

		public void actionPerformed(ActionEvent e) {
			publishActionCommand(HTSSyntax.ACTION_CHECK, null, null);
		}
	};
	
	public SwingRadioButton(JRadioButton radio, ComponentId id) {
		super(radio, id);
	}

	public void check() throws ComponentException {
		assertEditable();
		
		if( !isChecked() )
			select();
	}

	public boolean isChecked() throws ComponentException {
		assertReadable();
		return getButton().isSelected();
	}
	
	public ICommandCreator initCommandCreator(IHTSCommandReceiver receiver) {
		return new RadioButtonCommandCreator(this, receiver);
	}
}
