/*
 * Created on 17.06.2006
 */
package atosj.component.swt;

import java.util.Vector;

import org.eclipse.swt.events.ArmEvent;
import org.eclipse.swt.events.ArmListener;
import org.eclipse.swt.events.ControlEvent;
import org.eclipse.swt.events.ControlListener;
import org.eclipse.swt.events.FocusEvent;
import org.eclipse.swt.events.FocusListener;
import org.eclipse.swt.events.HelpEvent;
import org.eclipse.swt.events.HelpListener;
import org.eclipse.swt.events.KeyEvent;
import org.eclipse.swt.events.KeyListener;
import org.eclipse.swt.events.MenuEvent;
import org.eclipse.swt.events.MenuListener;
import org.eclipse.swt.events.ModifyEvent;
import org.eclipse.swt.events.ModifyListener;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.events.MouseListener;
import org.eclipse.swt.events.MouseMoveListener;
import org.eclipse.swt.events.MouseTrackListener;
import org.eclipse.swt.events.PaintEvent;
import org.eclipse.swt.events.PaintListener;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.events.ShellEvent;
import org.eclipse.swt.events.ShellListener;
import org.eclipse.swt.events.TraverseEvent;
import org.eclipse.swt.events.TraverseListener;
import org.eclipse.swt.events.TreeEvent;
import org.eclipse.swt.events.TreeListener;
import org.eclipse.swt.events.VerifyEvent;
import org.eclipse.swt.events.VerifyListener;
import org.eclipse.swt.widgets.Widget;

import atosj.component.EventMonitorWrapper;
import atosj.util.swteventmonitor.SWTEventMonitor;

/**
 * Realisiert das Multi-Casting von Ereignissen an die, durch die <code>SWTCommandCreator</code> 
 * initialisierten, Listener. Implementiert alle Listenertypen der SWT Architektur und registriert
 * sich beim <code>SWTEventMonitor</code> 
 * @author Nicos Tegos
 * @see atosj.util.swteventmonitor.SWTEventMonitor
 */
public class SWTEventMonitorWrapper extends EventMonitorWrapper
implements ArmListener, ControlListener, FocusListener, HelpListener,
KeyListener, MenuListener, ModifyListener, MouseListener,
MouseMoveListener, MouseTrackListener, PaintListener, SelectionListener,
ShellListener, TraverseListener, TreeListener, VerifyListener
{
	public SWTEventMonitorWrapper() 
	{
		super();
		
		SWTEventMonitor.addArmListener(this);
		SWTEventMonitor.addControlListener(this);
		SWTEventMonitor.addFocusListener(this);
		SWTEventMonitor.addHelpListener(this);
		SWTEventMonitor.addKeyListener(this);
		SWTEventMonitor.addMenuListener(this);
		SWTEventMonitor.addModifyListener(this);
		SWTEventMonitor.addMouseListener(this);
		SWTEventMonitor.addMouseMoveListener(this);
		SWTEventMonitor.addMouseTrackListener(this);
		SWTEventMonitor.addPaintListener(this);
		SWTEventMonitor.addSelectionListener(this);
		SWTEventMonitor.addShellListener(this);
		SWTEventMonitor.addTraverseListener(this);
		SWTEventMonitor.addTreeListener(this);
		SWTEventMonitor.addVerifyListener(this);
	}

	/* (non-Javadoc)
	 * @see org.eclipse.swt.events.ArmListener#widgetArmed(org.eclipse.swt.events.ArmEvent)
	 */
	public void widgetArmed(ArmEvent arg0) {
		Vector listeners = getListeners( arg0.widget );
		if(listeners != null)
		{
			for(int i = 0; i < listeners.size(); ++i)
			{
				if(listeners.get(i) instanceof ArmListener)
					((ArmListener)listeners.get(i)).widgetArmed(arg0);
			}
		}
	}

	/* (non-Javadoc)
	 * @see org.eclipse.swt.events.ControlListener#controlMoved(org.eclipse.swt.events.ControlEvent)
	 */
	public void controlMoved(ControlEvent arg0) {
		Vector listeners = getListeners( arg0.widget );
		if(listeners != null)
		{
			for(int i = 0; i < listeners.size(); ++i)
			{
				if(listeners.get(i) instanceof ControlListener)
					((ControlListener)listeners.get(i)).controlMoved(arg0);
			}
		}
	}

	/* (non-Javadoc)
	 * @see org.eclipse.swt.events.ControlListener#controlResized(org.eclipse.swt.events.ControlEvent)
	 */
	public void controlResized(ControlEvent arg0) {
		Vector listeners = getListeners( arg0.widget );
		if(listeners != null)
		{
			for(int i = 0; i < listeners.size(); ++i)
			{
				if(listeners.get(i) instanceof ControlListener)
					((ControlListener)listeners.get(i)).controlResized(arg0);
			}
		}
	}

	/* (non-Javadoc)
	 * @see org.eclipse.swt.events.FocusListener#focusGained(org.eclipse.swt.events.FocusEvent)
	 */
	public void focusGained(FocusEvent arg0) {
		Vector listeners = getListeners( arg0.widget );
		if(listeners != null)
		{
			for(int i = 0; i < listeners.size(); ++i)
			{
				if(listeners.get(i) instanceof FocusListener)
					((FocusListener)listeners.get(i)).focusGained(arg0);
			}
		}
	}

	/* (non-Javadoc)
	 * @see org.eclipse.swt.events.FocusListener#focusLost(org.eclipse.swt.events.FocusEvent)
	 */
	public void focusLost(FocusEvent arg0) {
		Vector listeners = getListeners( arg0.widget );
		if(listeners != null)
		{
			for(int i = 0; i < listeners.size(); ++i)
			{
				if(listeners.get(i) instanceof FocusListener)
					((FocusListener)listeners.get(i)).focusLost(arg0);
			}
		}
	}

	/* (non-Javadoc)
	 * @see org.eclipse.swt.events.HelpListener#helpRequested(org.eclipse.swt.events.HelpEvent)
	 */
	public void helpRequested(HelpEvent arg0) {
		Vector listeners = getListeners( arg0.widget );
		if(listeners != null)
		{
			for(int i = 0; i < listeners.size(); ++i)
			{
				if(listeners.get(i) instanceof HelpListener)
					((HelpListener)listeners.get(i)).helpRequested(arg0);
			}
		}
	}

	/* (non-Javadoc)
	 * @see org.eclipse.swt.events.KeyListener#keyPressed(org.eclipse.swt.events.KeyEvent)
	 */
	public void keyPressed(KeyEvent arg0) {
		Vector listeners = getListeners( arg0.widget );
		if(listeners != null)
		{
			for(int i = 0; i < listeners.size(); ++i)
			{
				if(listeners.get(i) instanceof KeyListener)
					((KeyListener)listeners.get(i)).keyPressed(arg0);
			}
		}
	}

	/* (non-Javadoc)
	 * @see org.eclipse.swt.events.KeyListener#keyReleased(org.eclipse.swt.events.KeyEvent)
	 */
	public void keyReleased(KeyEvent arg0) {
		Vector listeners = getListeners( arg0.widget );
		if(listeners != null)
		{
			for(int i = 0; i < listeners.size(); ++i)
			{
				if(listeners.get(i) instanceof KeyListener)
					((KeyListener)listeners.get(i)).keyReleased(arg0);
			}
		}
	}

	/* (non-Javadoc)
	 * @see org.eclipse.swt.events.MenuListener#menuHidden(org.eclipse.swt.events.MenuEvent)
	 */
	public void menuHidden(MenuEvent arg0) {
		Vector listeners = getListeners( arg0.widget );
		if(listeners != null)
		{
			for(int i = 0; i < listeners.size(); ++i)
			{
				if(listeners.get(i) instanceof MenuListener)
					((MenuListener)listeners.get(i)).menuHidden(arg0);
			}
		}
	}

	/* (non-Javadoc)
	 * @see org.eclipse.swt.events.MenuListener#menuShown(org.eclipse.swt.events.MenuEvent)
	 */
	public void menuShown(MenuEvent arg0) {
		Vector listeners = getListeners( arg0.widget );
		if(listeners != null)
		{
			for(int i = 0; i < listeners.size(); ++i)
			{
				if(listeners.get(i) instanceof MenuListener)
					((MenuListener)listeners.get(i)).menuShown(arg0);
			}
		}
	}

	/* (non-Javadoc)
	 * @see org.eclipse.swt.events.ModifyListener#modifyText(org.eclipse.swt.events.ModifyEvent)
	 */
	public void modifyText(ModifyEvent arg0) {
		Vector listeners = getListeners( arg0.widget );
		if(listeners != null)
		{
			for(int i = 0; i < listeners.size(); ++i)
			{
				if(listeners.get(i) instanceof ModifyListener)
					((ModifyListener)listeners.get(i)).modifyText(arg0);
			}
		}
	}

	/* (non-Javadoc)
	 * @see org.eclipse.swt.events.MouseListener#mouseDoubleClick(org.eclipse.swt.events.MouseEvent)
	 */
	public void mouseDoubleClick(MouseEvent arg0) {
		Vector listeners = getListeners( arg0.widget );
		if(listeners != null)
		{
			for(int i = 0; i < listeners.size(); ++i)
			{
				if(listeners.get(i) instanceof MouseListener)
					((MouseListener)listeners.get(i)).mouseDoubleClick(arg0);
			}
		}
	}

	/* (non-Javadoc)
	 * @see org.eclipse.swt.events.MouseListener#mouseDown(org.eclipse.swt.events.MouseEvent)
	 */
	public void mouseDown(MouseEvent arg0) {
		Vector listeners = getListeners( arg0.widget );
		if(listeners != null)
		{
			for(int i = 0; i < listeners.size(); ++i)
			{
				if(listeners.get(i) instanceof MouseListener)
					((MouseListener)listeners.get(i)).mouseDown(arg0);
			}
		}
	}

	/* (non-Javadoc)
	 * @see org.eclipse.swt.events.MouseListener#mouseUp(org.eclipse.swt.events.MouseEvent)
	 */
	public void mouseUp(MouseEvent arg0) {
		Vector listeners = getListeners( arg0.widget );
		if(listeners != null)
		{
			for(int i = 0; i < listeners.size(); ++i)
			{
				if(listeners.get(i) instanceof MouseListener)
					((MouseListener)listeners.get(i)).mouseUp(arg0);
			}
		}
	}

	/* (non-Javadoc)
	 * @see org.eclipse.swt.events.MouseMoveListener#mouseMove(org.eclipse.swt.events.MouseEvent)
	 */
	public void mouseMove(MouseEvent arg0) {
		Vector listeners = getListeners( arg0.widget );
		if(listeners != null)
		{
			for(int i = 0; i < listeners.size(); ++i)
			{
				if(listeners.get(i) instanceof MouseMoveListener)
					((MouseMoveListener)listeners.get(i)).mouseMove(arg0);
			}
		}
	}

	/* (non-Javadoc)
	 * @see org.eclipse.swt.events.MouseTrackListener#mouseEnter(org.eclipse.swt.events.MouseEvent)
	 */
	public void mouseEnter(MouseEvent arg0) {
		Vector listeners = getListeners( arg0.widget );
		if(listeners != null)
		{
			for(int i = 0; i < listeners.size(); ++i)
			{
				if(listeners.get(i) instanceof MouseTrackListener)
					((MouseTrackListener)listeners.get(i)).mouseEnter(arg0);
			}
		}
	}

	/* (non-Javadoc)
	 * @see org.eclipse.swt.events.MouseTrackListener#mouseExit(org.eclipse.swt.events.MouseEvent)
	 */
	public void mouseExit(MouseEvent arg0) {
		Vector listeners = getListeners( arg0.widget );
		if(listeners != null)
		{
			for(int i = 0; i < listeners.size(); ++i)
			{
				if(listeners.get(i) instanceof MouseTrackListener)
					((MouseTrackListener)listeners.get(i)).mouseExit(arg0);
			}
		}
	}

	/* (non-Javadoc)
	 * @see org.eclipse.swt.events.MouseTrackListener#mouseHover(org.eclipse.swt.events.MouseEvent)
	 */
	public void mouseHover(MouseEvent arg0) {
		Vector listeners = getListeners( arg0.widget );
		if(listeners != null)
		{
			for(int i = 0; i < listeners.size(); ++i)
			{
				if(listeners.get(i) instanceof MouseTrackListener)
					((MouseTrackListener)listeners.get(i)).mouseHover(arg0);
			}
		}
	}

	/* (non-Javadoc)
	 * @see org.eclipse.swt.events.PaintListener#paintControl(org.eclipse.swt.events.PaintEvent)
	 */
	public void paintControl(PaintEvent arg0) {
		Vector listeners = getListeners( arg0.widget );
		if(listeners != null)
		{
			for(int i = 0; i < listeners.size(); ++i)
			{
				if(listeners.get(i) instanceof PaintListener)
					((PaintListener)listeners.get(i)).paintControl(arg0);
			}
		}
	}

	/* (non-Javadoc)
	 * @see org.eclipse.swt.events.SelectionListener#widgetSelected(org.eclipse.swt.events.SelectionEvent)
	 */
	public void widgetSelected(SelectionEvent arg0) {
		Vector listeners = getListeners( arg0.widget );
		if(listeners != null)
		{
			for(int i = 0; i < listeners.size(); ++i)
			{
				if(listeners.get(i) instanceof SelectionListener)
					((SelectionListener)listeners.get(i)).widgetSelected(arg0);
			}
		}
	}

	/* (non-Javadoc)
	 * @see org.eclipse.swt.events.SelectionListener#widgetDefaultSelected(org.eclipse.swt.events.SelectionEvent)
	 */
	public void widgetDefaultSelected(SelectionEvent arg0) {
		Vector listeners = getListeners( arg0.widget );
		if(listeners != null)
		{
			for(int i = 0; i < listeners.size(); ++i)
			{
				if(listeners.get(i) instanceof SelectionListener)
					((SelectionListener)listeners.get(i)).widgetDefaultSelected(arg0);
			}
		}
	}

	/* (non-Javadoc)
	 * @see org.eclipse.swt.events.ShellListener#shellActivated(org.eclipse.swt.events.ShellEvent)
	 */
	public void shellActivated(ShellEvent arg0) {
		Vector listeners = getListeners( arg0.widget );
		if(listeners != null)
		{
			for(int i = 0; i < listeners.size(); ++i)
			{
				if(listeners.get(i) instanceof ShellListener)
					((ShellListener)listeners.get(i)).shellActivated(arg0);
			}
		}
	}

	/* (non-Javadoc)
	 * @see org.eclipse.swt.events.ShellListener#shellClosed(org.eclipse.swt.events.ShellEvent)
	 */
	public void shellClosed(ShellEvent arg0) {
		Vector listeners = getListeners( arg0.widget );
		if(listeners != null)
		{
			for(int i = 0; i < listeners.size(); ++i)
			{
				if(listeners.get(i) instanceof ShellListener)
					((ShellListener)listeners.get(i)).shellClosed(arg0);
			}
		}
	}

	/* (non-Javadoc)
	 * @see org.eclipse.swt.events.ShellListener#shellDeactivated(org.eclipse.swt.events.ShellEvent)
	 */
	public void shellDeactivated(ShellEvent arg0) {
		Vector listeners = getListeners( arg0.widget );
		if(listeners != null)
		{
			for(int i = 0; i < listeners.size(); ++i)
			{
				if(listeners.get(i) instanceof ShellListener)
					((ShellListener)listeners.get(i)).shellDeactivated(arg0);
			}
		}
	}

	/* (non-Javadoc)
	 * @see org.eclipse.swt.events.ShellListener#shellDeiconified(org.eclipse.swt.events.ShellEvent)
	 */
	public void shellDeiconified(ShellEvent arg0) {
		Vector listeners = getListeners( arg0.widget );
		if(listeners != null)
		{
			for(int i = 0; i < listeners.size(); ++i)
			{
				if(listeners.get(i) instanceof ShellListener)
					((ShellListener)listeners.get(i)).shellDeiconified(arg0);
			}
		}
	}

	/* (non-Javadoc)
	 * @see org.eclipse.swt.events.ShellListener#shellIconified(org.eclipse.swt.events.ShellEvent)
	 */
	public void shellIconified(ShellEvent arg0) {
		Vector listeners = getListeners( arg0.widget );
		if(listeners != null)
		{
			for(int i = 0; i < listeners.size(); ++i)
			{
				if(listeners.get(i) instanceof ShellListener)
					((ShellListener)listeners.get(i)).shellIconified(arg0);
			}
		}
	}

	/* (non-Javadoc)
	 * @see org.eclipse.swt.events.TraverseListener#keyTraversed(org.eclipse.swt.events.TraverseEvent)
	 */
	public void keyTraversed(TraverseEvent arg0) {
		Vector listeners = getListeners( arg0.widget );
		if(listeners != null)
		{
			for(int i = 0; i < listeners.size(); ++i)
			{
				if(listeners.get(i) instanceof TraverseListener)
					((TraverseListener)listeners.get(i)).keyTraversed(arg0);
			}
		}
	}

	/* (non-Javadoc)
	 * @see org.eclipse.swt.events.TreeListener#treeCollapsed(org.eclipse.swt.events.TreeEvent)
	 */
	public void treeCollapsed(TreeEvent arg0) {
		Vector listeners = getListeners( arg0.widget );
		if(listeners != null)
		{
			for(int i = 0; i < listeners.size(); ++i)
			{
				if(listeners.get(i) instanceof TreeListener)
					((TreeListener)listeners.get(i)).treeCollapsed(arg0);
			}
		}
	}

	/* (non-Javadoc)
	 * @see org.eclipse.swt.events.TreeListener#treeExpanded(org.eclipse.swt.events.TreeEvent)
	 */
	public void treeExpanded(TreeEvent arg0) {
		Vector listeners = getListeners( arg0.widget );
		if(listeners != null)
		{
			for(int i = 0; i < listeners.size(); ++i)
			{
				if(listeners.get(i) instanceof TreeListener)
					((TreeListener)listeners.get(i)).treeExpanded(arg0);
			}
		}
	}

	/* (non-Javadoc)
	 * @see org.eclipse.swt.events.VerifyListener#verifyText(org.eclipse.swt.events.VerifyEvent)
	 */
	public void verifyText(VerifyEvent arg0) {
		Vector listeners = getListeners( arg0.widget );
		if(listeners != null)
		{
			for(int i = 0; i < listeners.size(); ++i)
			{
				if(listeners.get(i) instanceof VerifyListener)
					((VerifyListener)listeners.get(i)).verifyText(arg0);
			}
		}
	}
	
	/**
	 * Gibt <code>true</code> zurck, wenn die Ereignisquelle von <code>org.eclipse.swt.Widget</code>
	 * abgeleitet ist, <code>false</code> sonst.
	 * @param source Die Ereignisquelle.
	 */
	protected boolean isComponent(Object source) {
		if(source instanceof Widget)
			return true;
		
		return false;
	}
}
