/*
 * Created on 17.12.2005
 */
package atosj.dialog;

import org.eclipse.swt.graphics.Image;

import atosj.app.AtosJApp;
import atosj.gui.BaseLabelProvider;

/**
 * <code>LabelProvider</code> fr den <code>TableViewer</code> zur Angabe des Classpath des Testobjekts
 * im Projekt erstellen Dialog. Liefert Bilder entsprechend des Typs des Klassenpfadelements (jar oder 
 * Verzeichnis).
 * @author Nicos Tegos
 */
public class ClassPathLabelProvider extends BaseLabelProvider {
	
	/* (non-Javadoc)
	 * @see atosj.gui.BaseLabelProvider#getImage(java.lang.Object)
	 */
	public Image getColumnImage(Object element, int columnIndex) {
		if( ((String)element).endsWith(".jar") )
			return AtosJApp.getInstance().getImage(AtosJApp.IMG_JAR);
		else
			return AtosJApp.getInstance().getImage(AtosJApp.IMG_FOLDER);
	}
	
	/* (non-Javadoc)
	 * @see atosj.gui.BaseLabelProvider#getText(java.lang.Object)
	 */
	public String getColumnText(Object element, int columnIndex) {
		return (String) element;
	}
	
	/* (non-Javadoc)
	 * @see atosj.gui.BaseLabelProvider#isLabelProperty(java.lang.Object, java.lang.String)
	 */
	public boolean isLabelProperty(Object element, String property) {
		return true;
	}
}
