/*
 * Created on 17.12.2005
 */
package atosj.dialog;

import org.eclipse.jface.viewers.Viewer;
import org.eclipse.jface.viewers.ViewerSorter;

/**
 * <code>ViewerSorter</code> fr den <code>TableViewer</code> zur Angabe des Classpath des Testobjekts
 * im Projekt erstellen Dialog.
 * Vergleicht zwei Strings aus dem Classpath miteinander, wobei
 * jars immer nach Verzeichnissen kommen.
 * @author Nicos Tegos
 */
public class ClassPathSorter extends ViewerSorter {
	/* (non-Javadoc)
	 * @see org.eclipse.jface.viewers.ViewerSorter#compare(org.eclipse.jface.viewers.Viewer, java.lang.Object, java.lang.Object)
	 */
	final public int compare(Viewer viewer, Object e1, Object e2) {
		int cat1 = category(e1);
		int cat2 = category(e2);

		if (cat1 != cat2)
			return cat1 - cat2;
		
		return ((String)e1).compareTo((String) e2);
	}
	
	/*
	 * @see org.eclipse.jface.viewers.ViewerSorter#category(java.lang.Object)
	 */
	public int category(Object element) 
	{
		if( ((String)element).endsWith(".jar") )
			return 1;
		else
			return 0;
	}
}
