/*
 * Created on 10.12.2005
 */
package atosj.dialog;

import atosj.Messages;
import atosj.rmi.HTSPlayer;

/**
 * <code>ContentProvider</code> fr Tabelle zur Anzeige von Statistiken einzelner Kommandos.
 * Liefert den Ausfhrungsstatus der Kommandos eines <code>HTSPlayer</code>.
 * @author Nicos Tegos
 */
public class CommandStatisticsTableContentProvider extends StatisticsTableContentProvider 
{
	public static final String[] PROPERTIES = new String[] {Messages.getString("CommandStatisticsTableContentProvider.0"), Messages.getString("CommandStatisticsTableContentProvider.1"), Messages.getString("CommandStatisticsTableContentProvider.2"), Messages.getString("CommandStatisticsTableContentProvider.3"), Messages.getString("CommandStatisticsTableContentProvider.4") }; //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$
	private int scriptIndex;
	
	/**
	 * Erstellt einen neuen <code>ContentProvider</code>.
	 * @param scriptIndex Index des auszufhrenden Skriptes in dem die Kommandos enthalten sind,
	 * zu denen die Statistiken geliefert werden sollen.
	 */
	public CommandStatisticsTableContentProvider(int scriptIndex) {
		this.scriptIndex = scriptIndex;
	}
	
	/** 
	 * Der <code>input</code> muss vom Typ <code>HTSPlayer</code> sein.
	 */
	public StatisticsTableElement[] createStatisticTableElements(Object input) {
		return ((HTSPlayer)input).getCommandStatistics(scriptIndex);
	}
}
