package atosj.dialog;

import org.eclipse.jface.dialogs.Dialog;
import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.Font;
import org.eclipse.swt.graphics.FontData;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;

import atosj.Messages;
import atosj.app.AtosJApp;

/**
 * Dialog zur Anzeige der Programmversion und der Programmierer.
 * @author Nicos Tegos
 */
public class InfoDlg extends Dialog {

	private Font boldFont;
	
	public InfoDlg(Shell parent) {
		super(parent);
	}
	
	protected void configureShell(Shell shell) {
		super.configureShell(shell);
		shell.setText(Messages.getString("InfoDlg.0")); //$NON-NLS-1$
	}
	
	/* (non-Javadoc)
	 * @see org.eclipse.jface.dialogs.Dialog#createContents(org.eclipse.swt.widgets.Composite)
	 */
	protected Control createDialogArea(Composite parent) 
	{
		Composite dlgArea =  new Composite(parent, SWT.NULL);
		dlgArea.setLayoutData( new GridData(GridData.FILL_BOTH) );
		GridLayout gl = new GridLayout(2, false);
		gl.marginWidth = gl.marginHeight = gl.verticalSpacing = 15;
		dlgArea.setLayout(gl);
		
		Label iconLbl = new Label(dlgArea, SWT.NULL);
		iconLbl.setImage( AtosJApp.getInstance().getImage(AtosJApp.IMG_ICON) );
		
		Label versionLbl = new Label(dlgArea, SWT.NULL);
		versionLbl.setText(Messages.getString("InfoDlg.1")); //$NON-NLS-1$
		FontData origFontData = versionLbl.getFont().getFontData()[0];
		boldFont = new Font(versionLbl.getDisplay(), origFontData.getName(), origFontData.getHeight(), SWT.BOLD);
		versionLbl.setFont(boldFont);
		
		Label author1 = new Label(dlgArea, SWT.NULL);
		author1.setText("Nicos Tegos:"); //$NON-NLS-1$
		
		Text email1 = new Text(dlgArea, SWT.READ_ONLY);
		email1.setText("tegos@informatik.hu-berlin.de"); //$NON-NLS-1$
		
		Label author2 = new Label(dlgArea, SWT.NULL);
		author2.setText("Volker Janetschek:"); //$NON-NLS-1$
		
		Text email2 = new Text(dlgArea, SWT.READ_ONLY);
		email2.setText("janetsch@informatik.hu-berlin.de"); //$NON-NLS-1$
		
		applyDialogFont(dlgArea);
		return dlgArea;
	}
	
	protected void createButtonsForButtonBar(Composite parent) {
		createButton(parent, OK, Messages.getString("InfoDlg.6"), true); //$NON-NLS-1$
	}
	
	public boolean close() {
		boldFont.dispose();
		return super.close();
	}
}
