package atosj.dialog;

import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.widgets.Shell;

/**
 * Dialog fr die Ausfhrung der Kommandos QUESTION und MESSAGE. Einfache Ableitung von <code>MessageDialog</code>
 * fr einen nicht modalen Dialog.
 * @author Nicos Tegos
 */
public class MessageWindow extends MessageDialog 
{
	private boolean closed = false;
	
	/**
	 * Parameter siehe <code>MessageDialog</code>.
	 */
	public MessageWindow(Shell parentShell, String dialogTitle,
            Image dialogTitleImage, String dialogMessage, int dialogImageType,
            String[] dialogButtonLabels, int defaultIndex)
	{
		super(parentShell, dialogTitle, dialogTitleImage, dialogMessage, dialogImageType, dialogButtonLabels, defaultIndex);
		setShellStyle(SWT.DIALOG_TRIM | getDefaultOrientation());
        setBlockOnOpen(false); 
	}
	
	
	public boolean close() {
		boolean ret = super.close();
		closed = true;
		return ret;
	}
	
	public boolean isClosed() {
		return closed;
	}
}
