/*
 * Created on 18.12.2005
 */
package atosj.dialog;

import atosj.model.script.HTSScript;

/**
 * Liefert Statistiken zur Ausfhrung eines Skriptes, zur
 * Anzeige in einer Tabelle.
 * @author Nicos Tegos
 */
public class ScriptStatisticsTableElement extends StatisticsTableElement
{
	public ScriptStatisticsTableElement(HTSScript script, int line) {
		super(script,line);
	}

	public HTSScript getScript() {
		return (HTSScript) getElement();
	}
	
	// labelprovider funktionen
	public String getScriptName() {
		return getScript().getName();
	}
	
	/**
	 * Liefert ein "X", wenn das Skript interaktiv ist, sonst "".
	 * @see HTSScript#isInteractive()
	 */
	public String getInteractive() {
		return getScript().isInteractive() ? "X" : "";
	}
	
	/**
	 * Liefert ein "X", wenn das Skript ein CLEANUP enthlt, sonst "".
	 * @see HTSScript#hasCleanup()
	 */
	public String getCleanup() {
		return getScript().hasCleanup() ? "X" : "";
	}
}