/*
 * Created on 18.12.2005
 */
package atosj.dialog;

import org.eclipse.jface.viewers.TableViewer;
import org.eclipse.swt.widgets.TableItem;

import atosj.app.AtosJApp;
import atosj.gui.BaseLabelProvider;

/**
 * <code>LabelProvider</code> fr die Statistiken zur Ausfhrung eines Skripts.
 * @author Nicos Tegos
 */
public class ScriptStatisticsTableLabelProvider extends BaseLabelProvider 
{
	private TableViewer tv;
	
	/**
	 * Erstellt einen neuen <code>LabelProvider</code> fr die angegebene Tabelle.
	 * @param tv Die Tabelle.
	 */
	public ScriptStatisticsTableLabelProvider(TableViewer tv) {
		this.tv = tv;
	}
	
	/**
	 * Liefert den Text fr die einzelnen Spalten der Tabelle.
	 * @param element Ein <code>ScriptStatisticsTableElement</code>
	 * @param columnIndex Der Spaltenindex mit folgender Bedeutung:<br>
	 * 0 = Nummer<br>
	 * 1 = Skriptname<br>
	 * 2 = Interactiv<br>
	 * 3 = Cleanup<br>
	 * 4 = Status<br>
	 * 5 = Dauer<br>
	 * @see ScriptStatisticsTableElement
	 */
	public String getColumnText(Object element, int columnIndex) 
	{
		ScriptStatisticsTableElement scriptElement = (ScriptStatisticsTableElement) element;
		switch(columnIndex)
		{
			case 0: return scriptElement.getLineNumber();
			case 1: return scriptElement.getScriptName();
			case 2: return scriptElement.getInteractive();
			case 3: return scriptElement.getCleanup(); 
			case 4:
				// dazugehriges TableItem suchen und Farbe setzen
				TableItem item = (TableItem) tv.testFindItem(scriptElement);
				item.setBackground(columnIndex, AtosJApp.getInstance().getColor(scriptElement.getStatusColor()) );
				return scriptElement.getStatus();
			case 5: return scriptElement.getAvgDuration();
			default: return "";
		}
	}
	
	public boolean isLabelProperty(Object element, String property) 
	{
		for(int i = 0; i < ScriptStatisticsTableContentProvider.PROPERTIES.length; ++i)
		{
			if( property.equals(ScriptStatisticsTableContentProvider.PROPERTIES[i]) )
				return true;
		}
		
		return false;
	}
}
