/*
 * Created on 20.04.2006
 */
package atosj.dialog.addcmd;

import java.util.Vector;

import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Text;

import atosj.Messages;
import atosj.model.hts.parser.HTSParser;

/**
 * Die Eingabesektion fr das Comment Kommando.
 * @author Nicos Tegos
 */
public class CommentSection extends CommandSection {

	private Text commentTxt;
	
	public CommentSection(Composite parent) {
		super(parent);
		
		Label lbl = new Label(this, SWT.NULL);
		lbl.setText(Messages.getString("CommentSection.0")); //$NON-NLS-1$
		
		commentTxt = new Text(this, SWT.BORDER);
		commentTxt.setLayoutData( new GridData(GridData.FILL_HORIZONTAL) );
	}
	
	/* (non-Javadoc)
	 * @see atosj.dialog.addcmd.CommandSection#setOrigParameters(java.lang.String[])
	 */
	public void setOrigParameters(String[] parameters) {
		commentTxt.setText( HTSParser.stripQuotes(parameters[0]) );
	}

	/* (non-Javadoc)
	 * @see atosj.dialog.addcmd.CommandSection#getCommandParameters()
	 */
	public Vector getCommandParameters() 
	{
		Vector parameters = new Vector(1);
		parameters.add( '"' + commentTxt.getText() + '"' );
		
		return parameters;
	}

	/* (non-Javadoc)
	 * @see atosj.dialog.addcmd.CommandSection#checkIntegrity()
	 */
	public boolean checkIntegrity() {
		if( commentTxt.getText().length() == 0 )
		{
			MessageDialog.openError(null, Messages.getString("CommentSection.1"), Messages.getString("CommentSection.2")); //$NON-NLS-1$ //$NON-NLS-2$
			commentTxt.setFocus();
			return false;
		}
		
		return true;
	}

}
