/*
 * Created on 20.01.2006
 */
package atosj.dialog.addcmd;

import java.util.Vector;

import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.KeyAdapter;
import org.eclipse.swt.events.KeyEvent;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Text;

import atosj.Messages;

/**
 * Dient zur Eingabe der Parameter fr das LOOP Kommando.
 * @author Nicos Tegos
 */
public class LoopSection extends CommandSection {

	private Text cyclesTxt; 
	
	public LoopSection(Composite parent) {
		super(parent);
		
		Label lbl = new Label(this, SWT.NULL);
		lbl.setText(Messages.getString("LoopSection.0")); //$NON-NLS-1$
		cyclesTxt = new Text(this, SWT.BORDER);
		cyclesTxt.setLayoutData( new GridData(GridData.FILL_HORIZONTAL) );
		cyclesTxt.addKeyListener( new KeyAdapter() {
			public void keyPressed(KeyEvent e) {
				e.doit = Character.isDigit(e.character) 
				|| Character.isISOControl(e.character);
			}
		});
	}

	/* (non-Javadoc)
	 * @see atosj.dialog.addcmd.CommandSection#setOrigParameters(java.lang.String[])
	 */
	public void setOrigParameters(String[] parameters) 
	{
		cyclesTxt.setText(parameters[0]);
	}
	
	public Vector getCommandParameters() 
	{
		Vector parameters = new Vector(1);
		if( !cyclesTxt.getText().equals("") ) //$NON-NLS-1$
			parameters.add( cyclesTxt.getText() );
		return parameters;
	}

	public boolean checkIntegrity() 
	{
		boolean ret = true;
		// nur ganze zahlen > 0 erlaubt
		try
		{
			int value = Integer.parseInt( cyclesTxt.getText() );
			if(value <= 0)
				ret = false;
		}
		catch(NumberFormatException e) {
			ret = false;
		}
		
		if(ret == false)
		{
			cyclesTxt.setFocus();
			MessageDialog.openError(null, Messages.getString("LoopSection.2"), Messages.getString("LoopSection.3")); //$NON-NLS-1$ //$NON-NLS-2$
		}
		
		return ret;
	}
}
