/*
 * Created on 24.01.2006
 */
package atosj.dialog.addcmd;

import java.util.Vector;

import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Text;

import atosj.Messages;
import atosj.model.hts.parser.HTSParser;


/**
 * Dient zur Eingabe der Parameter fr das MESSAGE Kommando.
 * @author Nicos Tegos
 * @see atosj.model.hts.command.HTSMessage
 */
public class MessageSection extends CommandSection {

	private Text messageTxt;
	public MessageSection(Composite parent) {
		super(parent);
		
		createContent();
	}
	
	private void createContent() {
		Label lbl = new Label(this, SWT.NULL);
		lbl.setText(Messages.getString("MessageSection.0")); //$NON-NLS-1$
		lbl.setLayoutData( new GridData(GridData.VERTICAL_ALIGN_BEGINNING) );
		messageTxt = new Text(this, SWT.BORDER | SWT.MULTI | SWT.V_SCROLL | SWT.H_SCROLL);
		GridData gd = new GridData(GridData.FILL_HORIZONTAL);
		gd.heightHint = 100;
		messageTxt.setLayoutData(gd);
	}
	
	/* (non-Javadoc)
	 * @see atosj.dialog.addcmd.CommandSection#setOrigParameters(java.lang.String[])
	 */
	public void setOrigParameters(String[] parameters) {
		messageTxt.setText( HTSParser.stripQuotes(parameters[0]) );
	}
	
	public Vector getCommandParameters() 
	{
		Vector parameters = new Vector(2);
		parameters.add( '"' + messageTxt.getText() + '"');
		
		return parameters;
	}

	public boolean checkIntegrity() 
	{
		if( messageTxt.getText().equals("") ) //$NON-NLS-1$
		{
			MessageDialog.openError(null, Messages.getString("MessageSection.2"), Messages.getString("MessageSection.3")); //$NON-NLS-1$ //$NON-NLS-2$
			messageTxt.setFocus();
			return false;
		}

		return true;
	}
}
