/*
 * Created on 20.01.2006
 */
package atosj.dialog.addcmd;

import java.util.Vector;

import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Text;

import atosj.Messages;
import atosj.model.hts.parser.HTSParser;

/**
 * Dient zur Eingabe der Parameter fr das START Kommando.
 * @author Nicos Tegos
 */
public class StartSection extends CommandSection 
{
	private Text commandLine; 
	
	public StartSection(Composite parent) {
		super(parent);
		
		Label lbl = new Label(this, SWT.NULL);
		lbl.setText(Messages.getString("StartSection.0")); //$NON-NLS-1$
		commandLine = new Text(this, SWT.BORDER);
		commandLine.setLayoutData( new GridData(GridData.FILL_HORIZONTAL) );
	}

	/* (non-Javadoc)
	 * @see atosj.dialog.addcmd.CommandSection#setOrigParameters(java.lang.String[])
	 */
	public void setOrigParameters(String[] parameters) {
		if(parameters.length > 0)
			commandLine.setText( HTSParser.stripQuotes(parameters[0]) );
	}
	
	public Vector getCommandParameters() 
	{
		Vector parameters = new Vector(1);
		if( !commandLine.getText().equals("") ) //$NON-NLS-1$
			parameters.add( '"' + commandLine.getText() + '"' );
		return parameters;
	}

	public boolean checkIntegrity() {
		return true;
	}
}
