/*
 * Created on 21.01.2006
 */
package atosj.dialog.addcmd;

import java.util.Vector;

import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.KeyAdapter;
import org.eclipse.swt.events.KeyEvent;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Text;

import atosj.Messages;

/**
 * Dient zur Eingabe der Parameter fr das WAIT Kommando.
 * @author Nicos Tegos
 */
public class WaitSection extends CommandSection 
{
	private Text durationTxt; 
	
	public WaitSection(Composite parent) {
		super(parent);
		
		Label lbl = new Label(this, SWT.NULL);
		lbl.setText(Messages.getString("WaitSection.0")); //$NON-NLS-1$
		durationTxt = new Text(this, SWT.BORDER);
		durationTxt.setLayoutData( new GridData(GridData.FILL_HORIZONTAL) );
		durationTxt.addKeyListener( new KeyAdapter() {
			public void keyPressed(KeyEvent e) {
				e.doit = Character.isDigit(e.character) 
				|| Character.isISOControl(e.character);
			}
		});
	}

	/* (non-Javadoc)
	 * @see atosj.dialog.addcmd.CommandSection#setOrigParameters(java.lang.String[])
	 */
	public void setOrigParameters(String[] parameters) {
		durationTxt.setText( parameters[0] );
	}
	
	public Vector getCommandParameters() 
	{
		Vector parameters = new Vector(1);
		if( !durationTxt.getText().equals("") ) //$NON-NLS-1$
			parameters.add( durationTxt.getText() );
		return parameters;
	}

	public boolean checkIntegrity() 
	{
		boolean ret = true;
		// nur ganze zahlen > 0 erlaubt
		try
		{
			int value = Integer.parseInt( durationTxt.getText() );
			if(value <= 0)
				ret = false;
		}
		catch(NumberFormatException e) 
		{
				ret = false;
		}
		
		if(ret == false)
		{
			durationTxt.setFocus();
			MessageDialog.openError(null, Messages.getString("WaitSection.2"), Messages.getString("WaitSection.3")); //$NON-NLS-1$ //$NON-NLS-2$
		}
		
		return ret;
	}
}
