/*
 * Created on 24.05.2006
 */
package atosj.dialog.addcmd.action;

import java.util.Vector;

import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Text;

import atosj.Messages;
import atosj.dialog.addcmd.CommandSection;
import atosj.model.hts.parser.HTSParser;

/**
 * Widget zur Eingabe von Parametern der Aktionsart EDIT.
 * Enthlt ein Textfeld zur Eingabe der Zeichenkette.
 * @author Nicos Tegos
 */
class EditSpecificationWidget extends CommandSection 
{
	private Text editTxt;
	
	/**
	 * Erstellt ein neues Widget zur Eingabe von Parametern der Aktionsart EDIT.
	 * @param parent Das graphische Vaterelement.
	 */
	public EditSpecificationWidget(Composite parent) {
		super(parent);

		// Textfeld zur fr die Texteingabe bei EDIT
		Label editLbl = new Label(this, SWT.NULL);
		editLbl.setLayoutData( new GridData(GridData.VERTICAL_ALIGN_BEGINNING) );
		editLbl.setText(Messages.getString("EditSpecificationWidget.0")); //$NON-NLS-1$
						
		editTxt = new Text(this, SWT.BORDER | SWT.MULTI | SWT.V_SCROLL | SWT.H_SCROLL);
		GridData gd = new GridData(GridData.FILL_HORIZONTAL);
		gd.heightHint = 70;
		editTxt.setLayoutData(gd);
	}
	
	/* (non-Javadoc)
	 * @see atosj.dialog.addcmd.CommandSection#setOrigParameters(java.lang.String[])
	 */
	public void setOrigParameters(String[] parameters) 
	{
		editTxt.setText( HTSParser.stripQuotes(parameters[0]) );
	}

	/* (non-Javadoc)
	 * @see atosj.dialog.addcmd.SpecificationWidget#checkIntegrity()
	 */
	public boolean checkIntegrity() {
		// der Text ist egal also immer true
		return true;
	}
	
	public Vector getCommandParameters() {
		Vector ret = new Vector(1);
		ret.add( "\"" + editTxt.getText() + "\"" ); //$NON-NLS-1$ //$NON-NLS-2$
		return ret;
	}

}
