package atosj.dialog.addcmd.action;

import java.util.Vector;

import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Text;

import atosj.Messages;
import atosj.dialog.addcmd.CommandSection;
import atosj.model.hts.parser.HTSParser;

/**
 * Widget zur Eingabe von Parametern der Aktionsart PROPERTY.
 * Enthlt Textfelder zur Eingabe der Eigenschaft und des Eigenschaftswertes.
 * @author Nicos Tegos
 */
public class PropertySpecWidget extends CommandSection 
{
	private Text propertyTxt;
	private Text valueTxt;
	
	/**
	 * Widget zur Eingabe von Parametern der Aktionsart PROPERTY.
	 * @param parent Das graph. Vaterelement.
	 */
	public PropertySpecWidget(Composite parent) {
		super(parent);
		
		Label lbl = new Label(this, SWT.NULL);
		lbl.setText(Messages.getString("PropertySpecWidget.0")); //$NON-NLS-1$
		propertyTxt = new Text(this, SWT.BORDER);
		propertyTxt.setLayoutData( new GridData(GridData.FILL_HORIZONTAL) );
		
		lbl = new Label(this, SWT.NULL);
		lbl.setText(Messages.getString("PropertySpecWidget.1")); //$NON-NLS-1$
		valueTxt = new Text(this, SWT.BORDER);
		valueTxt.setLayoutData( new GridData(GridData.FILL_HORIZONTAL) );
	}

	public void setOrigParameters(String[] parameters) {
		propertyTxt.setText( HTSParser.stripQuotes(parameters[0]) );
		valueTxt.setText( HTSParser.stripQuotes(parameters[1]) );
	}

	public Vector getCommandParameters() {
		Vector ret = new Vector(2);
		ret.add( '"' + propertyTxt.getText() + '"' );
		ret.add( '"' + valueTxt.getText() + '"' );
		return ret;
	}

	public boolean checkIntegrity() 
	{
		if( propertyTxt.getText().length() == 0 )
		{
			propertyTxt.setFocus();
			MessageDialog.openError(null, Messages.getString("PropertySpecWidget.2"), Messages.getString("PropertySpecWidget.3")); //$NON-NLS-1$ //$NON-NLS-2$
			return false;
		}
		
		return true;
	}

}
