package atosj.dialog.addcmd.test;

import java.util.Vector;

import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.jface.viewers.ComboViewer;
import org.eclipse.jface.viewers.StructuredSelection;
import org.eclipse.swt.widgets.Composite;

import atosj.Messages;
import atosj.dialog.addcmd.CommandSection;
import atosj.model.hts.parser.HTSSyntax;

/**
 * Widget zur Eingabe der Parameter einer booleschen Zustandprfung.
 * Enthlt eine Combobox mit dem Sollwert (TRUE oder FALSE).
 * @author Nicos Tegos
 */
class BoolSpecificationWidget extends CommandSection {

	private ComboViewer boolCV;
	private static final String[] VALUES = new String[] {HTSSyntax.COMPARE_TRUE, HTSSyntax.COMPARE_FALSE};
	
	/**
	 * Erstellt ein neues Widget zur Eingabe der Parameter einer booleschen Zustandprfung.
	 * @param parent Das graph. Vaterelement.
	 */
	public BoolSpecificationWidget(Composite parent) {
		super(parent);
		
		createContent();
	}

	protected void createContent() {
		boolCV = createComboViewer(Messages.getString("BoolSpecificationWidget.0")); //$NON-NLS-1$
		boolCV.setInput(VALUES);
	}
	
	public void setOrigParameters(String[] parameters) {
		boolCV.setSelection( new StructuredSelection(parameters[0]) );
	}

	public Vector getCommandParameters() {
		Vector ret = new Vector(1);
		ret.add( getSelectedElement(boolCV) );
		
		return ret;
	}

	public boolean checkIntegrity() {
		if( boolCV.getSelection().isEmpty() )
		{
			boolCV.getCombo().setFocus();
			MessageDialog.openError(null, Messages.getString("BoolSpecificationWidget.1"), Messages.getString("BoolSpecificationWidget.2")); //$NON-NLS-1$ //$NON-NLS-2$
			return false;
		}
		
		return true;
	}
}