/*
 * Created on 26.05.2006
 */
package atosj.dialog.addcmd.test;

import java.util.Vector;

import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Text;

import atosj.Messages;
import atosj.dialog.addcmd.CommandSection;
import atosj.model.hts.parser.HTSParser;

/**
 * Widget zur Eingabe fr die Parameter eines textuellen Vergleichs.
 * Enthlt ein Textfeld zur Eingabe des textuellen Sollwertes.
 * @author Nicos Tegos
 */
class TextSpecificationWidget extends CommandSection {

	private Text valueTxt;
	
	/**
	 * Erstellt ein neues Widget zur Eingabe fr die Parameter eines textuellen Vergleichs.
	 * @param parent Das graph. Vaterelement.
	 */
	public TextSpecificationWidget(Composite parent) 
	{
		super(parent);

		Label lbl = new Label(this, SWT.NULL);
		lbl.setLayoutData( new GridData(GridData.VERTICAL_ALIGN_BEGINNING) );
		lbl.setText(Messages.getString("TextSpecificationWidget.0")); //$NON-NLS-1$
						
		valueTxt = new Text(this, SWT.BORDER | SWT.V_SCROLL | SWT.H_SCROLL | SWT.MULTI);
		GridData gd = new GridData(GridData.FILL_HORIZONTAL);
		gd.heightHint = 80;
		valueTxt.setLayoutData(gd);
	}

	/* (non-Javadoc)
	 * @see atosj.dialog.addcmd.CommandSection#setOrigParameters(java.lang.String[])
	 */
	public void setOrigParameters(String[] parameters) {
		valueTxt.setText( HTSParser.stripQuotes(parameters[0]) );
	}
	
	/* (non-Javadoc)
	 * @see atosj.dialog.addcmd.CommandSection#getCommandParameters()
	 */
	public Vector getCommandParameters() {
		Vector parameters = new Vector(1);
		parameters.add( '"' + valueTxt.getText() + '"' );
		return parameters;
	}

	/* (non-Javadoc)
	 * @see atosj.dialog.addcmd.CommandSection#checkIntegrity()
	 */
	public boolean checkIntegrity() {
		return true;
	}

}
