package atosj.dialog.addcmd.test;

import java.util.Vector;

import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Text;

import atosj.Messages;
import atosj.dialog.addcmd.CommandSection;
import atosj.model.hts.parser.HTSParser;

/**
 * Widget zur Eingabe eines Variablennamens als Sollwert fr das Kommando COMPARE.
 * @author Nicos Tegos
 */
class VarSpecificationWidget extends CommandSection {

	private Text variableTxt;
	
	/**
	 * Erstellt ein neues Widget zur Eingabe eines Variablennamens als Sollwert fr das Kommando COMPARE.
	 * @param parent Das graph. Vaterelement.
	 */
	public VarSpecificationWidget(Composite parent) 
	{
		super(parent);

		Label lbl = new Label(this, SWT.NULL);
		lbl.setText(Messages.getString("VarSpecificationWidget.0")); //$NON-NLS-1$
						
		variableTxt = new Text(this, SWT.BORDER);
		variableTxt.setLayoutData( new GridData(GridData.FILL_HORIZONTAL) );
	}

	public void setOrigParameters(String[] parameters) {
		variableTxt.setText( HTSParser.stripQuotes(parameters[0]) );
	}
	
	public Vector getCommandParameters() {
		Vector parameters = new Vector(1);
		parameters.add( '"' + variableTxt.getText() + '"' );
		return parameters;
	}

	public boolean checkIntegrity() {
		if( variableTxt.getText().equals("") ) //$NON-NLS-1$
		{
			variableTxt.setFocus();
			MessageDialog.openError(null, Messages.getString("VarSpecificationWidget.2"), Messages.getString("VarSpecificationWidget.3")); //$NON-NLS-1$ //$NON-NLS-2$
			return false;
		}
		
		return true;
	}
}