/*
 * Created on 13.04.2006
 */
package atosj.editors;

/**
 * Diese Klasse reprsentiert eine Aktion eines Editors, die rckgngiggemacht 
 * werden kann.
 * @author Nicos Tegos
 */
public class UndoElement 
{
	private int operation;
	private Object obj;
	
	/**
	 * @param operation Ein Operationscode der dem <code>UndoManager</code>
	 * angibt, um welchen Aktionstyp es sich handelt.
	 * @param obj Alle Informationen, die bentigt werden, um die Aktion
	 * vollstndig rckgngig zu machen.
	 */
	public UndoElement(int operation, Object obj) {
		super();
		this.operation = operation;
		this.obj = obj;
	}

	/**
	 * Liefert die Informationen fr das  Rckgngigmachen der Aktion.
	 */
	public Object getObject() {
		return obj;
	}
	
	/**
	 * Liefert den Operationscode.
	 */
	public int getOperation() {
		return operation;
	}
}
