package atosj.editors.urf;

import atosj.component.ComponentId;
import atosj.gui.BaseLabelProvider;

/**
 * Liefert die Beschriftungen der Tabelle im <code>URFEditor</code>.
 * @author Nicos Tegos
 * @see atosj.editors.urf.URFEditor
 */
public class IdTableLabelProvider extends BaseLabelProvider
{
	/**
	 * Liefert den Text fr die einzelnen Spalten der Tabelle.
	 * @param element Eine <code>ComponentId</code>.
	 * @param colIndex Der Spaltenindex mit folgender Bedeutung:<br>
	 * 0 = Fenster<br>
	 * 1 = Name<br>
	 * 2 = HTS Typ<br>
	 * @see ComponentId
	 */
	public String getColumnText(Object element, int colIndex) {
		switch(colIndex)
		{
			case 0: return ((ComponentId)element).getWindowName();
			case 1: return ((ComponentId)element).getName();
			case 2: return ((ComponentId)element).getClassName();
			default: return "";
		}
	}
	
	/* (non-Javadoc)
	 * @see atosj.gui.BaseLabelProvider#isLabelProperty(java.lang.Object, java.lang.String)
	 */
	public boolean isLabelProperty(Object element, String property) {
		if( property.equals(URFEditor.PROP_NAME) 
				|| property.equals(URFEditor.PROP_WINDOWNAME) 
				|| property.equals(URFEditor.PROP_CLASSNAME)
				|| property.equals(URFEditor.PROP_POSTION))
			return true;
		
		return false;
	}
}
