package atosj.editors.urf;

import org.eclipse.jface.viewers.TreeViewer;
import org.eclipse.swt.graphics.Image;

import atosj.app.AtosJApp;
import atosj.gui.TreeEntry;
import atosj.gui.TreeNodeContainer;
import atosj.model.urf.URFFile;

/**
 * Ein Knoten fr die URF-Datei im Navigator-Baum.
 * @author Nicos Tegos
 * @see atosj.gui.MasterTreeContentProvider
 */
public class URFTreeEntry extends TreeEntry {

	/**
	 * Erstellt einen neuen Knoten fr die URF-Datei im Navigator-Baum.
	 * @param tv Der Navigator Baum.
	 * @param toWrap Das <code>URFFile</code>.
	 * @param parent Der Vaterknoten.
	 */
	public URFTreeEntry(TreeViewer tv, Object toWrap, TreeNodeContainer parent) {
		super(tv, toWrap, parent);
	}

	private URFFile getURFFile() {
		return (URFFile) getWrappedObject();
	}
	
	public String getName() {
		return getURFFile().isModified() ? "*" + getURFFile().getName() : getURFFile().getName();
	}
	
	public Image getImage() {
		return AtosJApp.getInstance().getImage(AtosJApp.IMG_ID);
	}
}
