package atosj.editors.urf;

import java.util.Comparator;

import atosj.component.ComponentId;

/**
 * Vergleicht zwei <code>ComponentId</code>s miteinander. Zuerst nach dem Fensternamen
 * und dann nach dem Compoentnamen.
 * @author Nicos Tegos
 */
public class WindowNameComparator implements Comparator {

	public int compare(Object arg0, Object arg1) {
		if(arg0 instanceof ComponentId && arg1 instanceof ComponentId)
		{
			ComponentId id0 = (ComponentId)arg0;
			ComponentId id1 = (ComponentId)arg1;
			
			int ret = id0.getWindowName().compareTo( id1.getWindowName() );
			if( ret == 0 )
				ret = id0.getName().compareTo( id1.getName() );
			
			return ret;
		}
		return 0;
	}
	
}
