/*
 * Created on 11.09.2005
 */
package atosj.event.awt;

import java.awt.Window;
import java.awt.event.WindowEvent;

import atosj.component.swing.SwingDialog;
import atosj.component.swing.SwingFrame;
import atosj.exception.ComponentException;


/**
 * Schickt ein AWT Event zum Schlieen eines Fensters.
 * Simuliert damit eine entsprechende Nutzeraktion.
 * @author Nicos Tegos
 */
public class CloseMainWindowEvent extends FireableSwingEvent
{
	/**
	 * Erstellt ein neues Ereignis zum Schlieen eines Fensters. 
	 * @param w Das Fenster.
	 */
	public CloseMainWindowEvent(SwingFrame w) {
		super(w);
	}
	
	/**
	 * Erstellt ein neues Ereignis zum Schlieen eins Dialogs. 
	 * @param w Der Dialog.
	 */
	public CloseMainWindowEvent(SwingDialog w) {
		super(w);
	}

	/**
	 * Lst das Ereignis aus, d.h. fgt es der AWT EventQueue hinzu.
	 */
	public void fire() throws ComponentException {
		postEvent( new WindowEvent( (Window) getComponent() , WindowEvent.WINDOW_CLOSING) );
	}
}
