package atosj.event.swt;

import atosj.component.swt.SWTComponent;

/**
 * Hilfsklasse, fr Ereignisse die einer programmatischen
 * Operation auf einem Component folgen mssen, um deren
 * Listener zu benachrichtigen.
 * @author Nicos Tegos
 */
public class NotifyEvent extends FireableSWTEvent {

	public NotifyEvent(SWTComponent component) {
		super(component);
	}
	
	/**
	 * Benachrichtigt alle Listener des Components ber
	 * das Auftreten von eines Events vom Typ <code>type</code>, fgt es jedoch
	 * nicht in die EventQueue ein. Es wird die Funktion
	 * <code>Widget.notifyListeners(int, Event)</code> genutzt.
	 * @param type Der Typ des SWT Events.
	 */
	public void fire(int type) {
		notifyListeners( generateEvent(type) );
	}
}
