/*
 * Created on 14.11.2005
 */
package atosj.exception;

import atosj.Messages;
import atosj.model.hts.command.HTSCommand;

/**
 * Ausnahme fr die fehlgeschlagenen Ausfhrung eines
 * HTS Kommandos.
 * @see atosj.model.hts.command.HTSCommand
 * @author Nicos Tegos
 */
public class ExecutionException extends AtosJException {

	/**
	 * Erstellt eine neue Ausnahme, bei fehlgeschlagener Ausfhrung von
	 * <code>cmd</code>.
	 * @param cmd Das Kommando welches gerade ausgefhrt wurde.
	 * @param message Die Fehlernachricht.
	 */
	public ExecutionException(HTSCommand cmd, String message) {
		super( createMessage(cmd,message) );
	}
	
	private static String createMessage(HTSCommand cmd, String message) {
		return Messages.getString("ExecutionException.0") + ( cmd.getIndex() + 1 ) //$NON-NLS-1$
		+ Messages.getString("ExecutionException.1") + message; //$NON-NLS-1$
	}
}
