/*
 * Created on 24.11.2005
 */
package atosj.exception;

import atosj.Messages;
import atosj.app.Project;
import atosj.component.ComponentId;
import atosj.model.hts.command.HTSCommand;
import atosj.model.script.HTSScript;

/**
 * Ausnahme, wenn in einem Kommando Components verwendet werden,
 * deren IDs nicht in der URF-Datei enthalten sind.
 * @author Nicos Tegos
 * @see HTSCommand#checkIntegrity(Project, HTSScript)
 * @see atosj.model.urf.URFFile
 * @see atosj.component.ComponentId
 */
public class IntegrityException extends AtosJException {

	public IntegrityException(HTSCommand command, String message) {
		super( createMessage(command, message) );
	}
	
	public IntegrityException(HTSCommand command, ComponentId id) {
		super( createMessage(command, id) );
	}

	private static String createMessage(HTSCommand command, String message) 
	{
		return Messages.getString("IntegrityException.0") + (command.getIndex()+1) + Messages.getString("IntegrityException.1")  //$NON-NLS-1$ //$NON-NLS-2$
				+ message;
		
	}
	
	private static String createMessage(HTSCommand command, ComponentId id) 
	{
		return Messages.getString("IntegrityException.2") + (command.getIndex()+1)  //$NON-NLS-1$
			+ Messages.getString("IntegrityException.3")  //$NON-NLS-1$
			+ id.toString();
	}
}
