/*
 * Created on 21.11.2005
 */
package atosj.gui;

import org.eclipse.jface.viewers.ILabelProvider;
import org.eclipse.jface.viewers.ILabelProviderListener;
import org.eclipse.jface.viewers.ITableLabelProvider;
import org.eclipse.swt.graphics.Image;

/**
 * Adapterklasse mit Standardimplentationen aller Methoden der Interfaces <code>ITableLabelProvider</code>
 * und <code>ILabelProvider</code>
 * @author Nicos Tegos
 */
public class BaseLabelProvider implements ITableLabelProvider, ILabelProvider {

	/**
	 * Liefert <code>null</code>.
	 */
	public Image getImage(Object element) {
		return null;
	}

	/**
	 * Liefert einen leeren String.
	 */
	public String getText(Object element) {
		return element.toString();
	}
	
	/**
	 * Liefert <code>null</code>.
	 */
	public Image getColumnImage(Object element, int columnIndex) {
		return null;
	}

	/**
	 * Liefert einen leeren String.
	 */
	public String getColumnText(Object element, int columnIndex) {
		return "";
	}

	/**
	 * Leere Implementation.
	 */
	public void addListener(ILabelProviderListener listener) {
	}

	/**
	 * Leere Implementation.
	 */
	public void dispose() {
	}

	/**
	 * Liefert immer <code>false</code>.
	 */
	public boolean isLabelProperty(Object element, String property) {
		return false;
	}

	/**
	 * Leere Implementation.
	 */
	public void removeListener(ILabelProviderListener listener) {
	}
}
