package atosj.gui;

import org.eclipse.jface.viewers.ITreeContentProvider;
import org.eclipse.jface.viewers.Viewer;

/**
 * Liefert die Elemente fr den Navigator Baum im
 * <code>MasterDetailsBlock</code>.
 * @author Nicos Tegos
 * @see atosj.gui.MasterDetailsBlock
 */
public class MasterTreeContentProvider implements ITreeContentProvider
{
	/**
	 * Liefert die Kinder eines <code>TreeEntry</code>.
	 * @param element Das <code>TreeEntry</code>.
	 * @see TreeEntry#getChildren()
	 */
	public Object[] getChildren(Object element) {
		return ((TreeEntry)element).getChildren();
	}
	
	/**
	 * Liefert den Vaterknoten eines <code>TreeEntry</code>.
	 * @param element Das <code>TreeEntry</code>.
	 * @see TreeEntry#getParent()
	 */
	public Object getParent(Object element) {
		return ((TreeEntry)element).getParent();
	}

	/**
	 * Liefert die Kindelement eines <code>TreeEntry</code>.
	 * @param element Ein <code>TreeEntry</code>.
	 * @see TreeEntry#hasChildren()
	 */
	public boolean hasChildren(Object element) {
		return ((TreeEntry)element).hasChildren();
	}

	/**
	 * Liefert fr ein Projekt alle Kinderknoten.
	 * @param inputElement Das <code>TreeProject</code>.
	 * @see TreeProject
	 */
	public Object[] getElements(Object inputElement) 
	{
		if(inputElement == null)
			return null;
		
		return ((TreeEntry)inputElement).getChildren();
	}

	public void dispose() {	}

	public void inputChanged(Viewer viewer, Object oldInput, Object newInput) {	}

}
