/*
 * Created on 25.11.2005
 */
package atosj.gui;

import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Label;

/**
 * Statische Klasse fr convenience Funktionen zur Arbeit mit SWT.
 * @author Nicos Tegos
 */
public class SWTToolkit 
{
	/**
	 * Erstellt einen Knopf im angegeben <code>component</code>, mit dem
	 * angegebenen Stil und der angegebenen Beschriftung.
	 */
	public static Button createButton(Composite parent, int style, String text) 
	{
		Button btn = new Button(parent, style);
		btn.setText(text);
		
		return btn;
	}
	
	/**
	 * Erstellt ein Label im angegeben <code>component</code>, mit der angegebenen Beschriftung.
	 */
	public static Label createLabel(Composite parent, String text) 
	{
		Label lbl = new Label(parent, SWT.NULL);
		lbl.setText(text);
		
		return lbl;
	}
}
