/*
 * Created on 24.01.2006
 */
package atosj.gui;

import org.eclipse.jface.action.IAction;
import org.eclipse.jface.action.ToolBarManager;
import org.eclipse.swt.SWT;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.ToolBar;

import atosj.Messages;
import atosj.action.project.NewProjectAction;
import atosj.action.project.OpenProjectAction;
import atosj.app.AtosJApp;

/**
 * Der Startbildschirm von ATOSj. Dieser prsentiert das ATOSj Logo und ist immer nach dem Start 
 * der Applikation zu sehen oder wenn gerade kein Projekt geffnet ist.
 * @author Nicos Tegos
 */
public class SplashScreen {

	private Image splash = AtosJApp.getInstance().getImage(AtosJApp.IMG_SPLASH);
	
	/**
	 * Erstellt den Startbildschirm.
	 * @param parent Das Hauptfenster.
	 */
	public SplashScreen(Composite parent) {
		GridLayout gl = new GridLayout(1, false);
		gl.marginHeight = gl.marginWidth = 10;
		parent.setLayout(gl);
		createSplashArea(parent);
	}

	/**
	 * Erstellt ein Zentrietes ATOSj Logo und zwei Knpfe zum
	 * ffnen und Erstellen eines Projekts.
	 */
	private void createSplashArea(Composite parent) {
		Composite splashArea = new Composite(parent, SWT.NULL);
		GridLayout gl = new GridLayout(1, false);
		splashArea.setLayout(gl);
		splashArea.setBackground( splashArea.getDisplay().getSystemColor(SWT.COLOR_WHITE) );
		splashArea.setLayoutData( new GridData(GridData.FILL_BOTH) );
		
		Composite spacer = new Composite(splashArea, SWT.NULL);
		spacer.setBackground( spacer.getDisplay().getSystemColor(SWT.COLOR_WHITE) );
		spacer.setLayoutData( new GridData(GridData.FILL_BOTH) );
		
		Label picture = new Label(splashArea, SWT.NULL);
		picture.setLayoutData( new GridData(GridData.HORIZONTAL_ALIGN_CENTER) );
		picture.setImage(splash);
		picture.setBackground( picture.getDisplay().getSystemColor(SWT.COLOR_WHITE) );
		
		ToolBarManager mngr = new ToolBarManager(SWT.VERTICAL|SWT.FLAT);
		IAction newAction = new NewProjectAction();
		newAction.setText(Messages.getString("SplashScreen.0")); //$NON-NLS-1$
		IAction openAction = new OpenProjectAction();
		openAction.setText(Messages.getString("SplashScreen.1")); //$NON-NLS-1$
		mngr.add(newAction);
		mngr.add(openAction);
		
		ToolBar bar = mngr.createControl(splashArea);
		bar.setBackground( splashArea.getDisplay().getSystemColor(SWT.COLOR_WHITE) );
		bar.setLayoutData( new GridData(GridData.HORIZONTAL_ALIGN_CENTER) );
		
		spacer = new Composite(splashArea, SWT.NULL);
		spacer.setBackground( spacer.getDisplay().getSystemColor(SWT.COLOR_WHITE) );
		spacer.setLayoutData( new GridData(GridData.FILL_BOTH) );
	}
}
