package atosj.gui;

import org.eclipse.jface.viewers.LabelProvider;
import org.eclipse.swt.graphics.Image;

/**
 * Liefert Icons und Beschriftungen fr die Knoten des 
 * Navigator Baumes im <code>MasterDetailsBlock</code>.
 * @author Nicos Tegos
 * @see atosj.gui.MasterDetailsBlock
 */
public class TreeEntryLabelProvider extends LabelProvider {

	/**
	 * Liefert das Bild.
	 * @param element Das <code>TreeEntry</code>.
	 * @see TreeEntry#getImage()
	 */
	public Image getImage(Object element) {
		return ((TreeEntry) element).getImage();
	}

	/**
	 * Liefert die Beschriftung.
	 * @param element Das <code>TreeEntry</code>.
	 * @see TreeEntry#getImage()
	 */
	public String getText(Object element) {
		return ((TreeEntry) element).getName();
	}
}
