/*
 * Created on 09.04.2006
 */
package atosj.listener;

/**
 * Dieser Listener wird vom <code>WindowMonitor</code> ber das ffnen und
 * Schlieen von Fenstern im Testobjekt informiert. 
 * @author Nicos Tegos
 * @see atosj.util.WindowMonitor
 */
public interface AtosJTopLevelWindowListener 
{
	/**
	 * Gibt an, dass ein Fenster im Testobjekt geffnet wurde.
	 * @param window Das geffnete Fenster. Es muss nach Bedarf in die tatschlichen 
	 * graph. Klassen gecastet werden z.B. java.awt.Window oder org.eclipse.swt.widgets.Shell.
	 */
	public void topLevelWindowCreated(Object window);
	/**
	 * Gibt an, dass ein Fenster im Testobjekt geschlossen wurde.
	 * @param window Das geschlossene Fenster. Es muss nach Bedarf in die tatschlichen 
	 * graph. Klassen gecastet werden z.B. java.awt.Window oder org.eclipse.swt.widgets.Shell.
	 */
	public void topLevelWindowDestroyed(Object window); 
}
