package atosj.listener;

import atosj.editors.Editor;

/**
 * Wird informiert ber den Wechsel des aktiven Editors
 * im Multi-Editor von ATOSj benachrichtigt.
 * @author Nicos Tegos
 */
public interface EditorListener 
{
	/**
	 * Benachrichtigt, dass der Editor zum Bearbeiten des
	 * Objektes <code>editMe</code> aktiviert wurde.
	 * @param editMe Das zu editierende Objekt oder <code>null</code>,
	 * falls alle Editoren geschlossen wurden.
	 */
	void editorActivated(Editor editMe);
}
