/*
 * Created on 20.02.2006
 */
package atosj.listener;

/**
 * Basis Interface fr den Informationsaustausch von <code>Receiver</code>-Klassen 
 * mit ihren Zuhrern. Alle ReceiverListener werden ber Zustandsnderungen
 * des Receivers ber dieses Interface oder dessen Ableitungen informiert.
 * <em>WICHTIG:</em> Zur Garantie der Vernderbarkeit von GUI-Elementen muss der Aufrufer
 * der Funktionen dieses Interfaces, also der <code>Receiver</code>, diese in einem GUI-Thread
 * mit Display.getDefault().asyncExec(Runnable) ausfhren.
 * @author Nicos Tegos
 * @see atosj.rmi.Receiver
 */
public interface ReceiverListener {
	/** 
	 * Die Ausfhrung des Testobjekts wurde gestartet oder beendet.
	 * @param running <code>true</code>, wenn die Ausfhrung
	 * gestartet wurde.
	 */
	public void runningStateChanged(boolean running);
}
