/*
 * Created on 24.11.2005
 */
package atosj.listener;

import atosj.editors.Changeable;

/**
 * Informiert ber nderungen eines Objekts vom
 * Typ <code>Changeable</code>.
 * @author Nicos Tegos
 * @see atosj.editors.Changeable
 */
public interface StateChangeListener 
{
	/** nderungsstatus */
	public static final int STATE_MODIFIED = 0;
	/** Gltigkeitsstatus */
	public static final int STATE_VALID = 1;
	/** Name */
	public static final int STATE_NAME = 2;
	
	/**
	 * Informiert ber nderungen von Eigenschaften.
	 * @param changed Das Element, dessen Eigenschaften sich gendert haben.
	 * @param state Konstante fr die Eigenschaftsart, siehe STATE_*.
	 * @param oldValue Der alte Zustandswert. Der Typ ist abhngig von <code>state</code>.
	 * @param newValue Der neue Zustandswert. Der Typ ist abhngig von <code>state</code>.
	 */
	void stateChanged(Changeable changed, int state, Object oldValue, Object newValue);
}
