/*
 * Created on 18.02.2006
 */
package atosj.listener;

/**
 * Wird informiert ber neue Zeichen im InputStream eines Prozesses,
 * also in stdout oder stderr.
 * @author Nicos Tegos
 */
public interface StreamListener {
	/**
	 * Wird informiert das neue Zeichen in den Stream des
	 * Prozesses gesschrieben wurden.
	 * @param chars Die neuen Zeichen.
	 */
	public void charsReceived(char[] chars);
	
	/**
	 * Wird gerufen wenn der Prozess beendet wurde und alle Zeichen
	 * aus dem Stream ausgelesen wurden. 
	 */
	public void streamFinished();
}
