package atosj.model.hts.command;

import atosj.exception.ExecutionException;
import atosj.exception.ParseException;
import atosj.rmi.HTSPlayer;
import atosj.rmi.IHTSPlayer;
import atosj.util.CSVLine;

/**
 * Klasse zum Parsen und Ausfhren eines HTS CLEANUP Kommandos.
 * @author Nicos Tegos
 */
public class HTSCleanup extends HTSCommand
{
	/**
	 * Erstellt ein neues CLEANUP-Kommando.
	 * @param line Kommaspeparierte Liste des Kommandos.
	 */
	public HTSCleanup(CSVLine line)
			throws ParseException {
		super(line);
	}

	/**
	 * Leitet weiter an die Methode <code>cleanup</code> aus <code>IHTSPlayer</code>.
	 * @see IHTSPlayer#cleanup()
	 */
	public void execute(IHTSPlayer player) throws ExecutionException {
		((HTSPlayer)player).cleanup();
	}
	
	public Object clone() {
		try {
			return new HTSCleanup( (CSVLine) line.clone() );
		} catch(ParseException e) {
			return null;
		}
	}
}
