/*
 * Created on 20.04.2006
 */
package atosj.model.hts.command;

import atosj.Messages;
import atosj.exception.ExecutionException;
import atosj.exception.ParseException;
import atosj.rmi.IHTSPlayer;
import atosj.util.CSVLine;

/**
 * Klasse das HTS COMMENT Kommando.
 * @author Nicos Tegos
 */
public class HTSComment extends HTSCommand {

	/**
	 * Erstellt einen neuen Kommentar.
	 * @param line Kommaspeparierte Liste des Kommandos.
	 */
	public HTSComment(CSVLine line) throws ParseException {
		super(line);
		
		getParamUnquoted(0, Messages.getString("HTSComment.0")); //$NON-NLS-1$
		assertParamSize(1);
	}

	/**
	 * Ein Kommentar kann nicht ausgefhrt werden :-)
	 */
	public void execute(IHTSPlayer player) throws ExecutionException {
		// cannot execute
	}

	/* (non-Javadoc)
	 * @see java.lang.Object#clone()
	 */
	public Object clone() {
		try {
			return new HTSComment( (CSVLine) line.clone() );
		} catch (ParseException e) {
			// will never happen
			return null;
		}
	}

}
