/*
 * Created on 21.01.2006
 */
package atosj.model.hts.command;

import atosj.Messages;
import atosj.exception.ExecutionException;
import atosj.exception.ParseException;
import atosj.rmi.IHTSPlayer;
import atosj.util.CSVLine;
import atosj.util.Snooze;

/**
 * Klasse zum Parsen und Ausfhren eines HTS WAIT Kommandos.
 * @author Nicos Tegos
 */
public class HTSWait extends HTSCommand 
{
	private int duration; // Wartedauer in ms
	
	/**
	 * Erstellt ein neues WAIT-Kommando.
	 * @param line Kommaspeparierte Liste des Kommandos.
	 */
	public HTSWait(CSVLine line) throws ParseException {
		super(line);
		
		// WAIT, <duration>
		duration = getNum(0, 1, Messages.getString("HTSWait.0")).intValue(); //$NON-NLS-1$
		assertParamSize(1);
	}

	/** Hlt den aktuellen Thread fr die angegebene Dauer an. */
	public void execute(IHTSPlayer player) throws ExecutionException {
		new Snooze(duration);
	}

	public Object clone() {
		try {
			return new HTSWait( (CSVLine) line.clone() );
		} catch(ParseException e) {
			return null;
		}
	}
}
