package atosj.model.hts.command;

import java.util.Vector;

import atosj.exception.ParseException;

/**
 * Stellt den Subelementpfad zusammen fr ein Kommando, das auf einem Unterelement
 * eines zusammengesetzten Components ausgefhrt wird z.B. das Auslesen der Beschriftung
 * einer Tabellenzelle. Der Subelementpfad gibt an, welches Unterelement gemeint ist, fr
 * ein Tabellenzelle setzt er sich beispielsweise aus dem Zeilen- und dem Spaltenindex zusammen.
 */
public abstract class SubitemPathValidator 
{
	/**
	 * Gibt den Subelement Pfad zurck.
	 * @param paramIndex Der Index des ersten Paramters nach dem Schlsselwort SUBITEM
	 * @return Vector der Subelemente, enthaltenen Werite sind entweder vom Typ Integer fr Zahlen 
	 * oder vom Typ String fr Zeichenketten. Zeichenketten werden ohne Anfhrungszeichen 
	 * bergeben.
	 */
	public abstract Vector getSubitemPath(int paramIndex) throws ParseException;
}
