package atosj.model.hts.parser;

/**
 * Definiert Konstanten zu allen Schlsselworten der HTS Syntax.
 * @author Nicos Tegos
 */
public class HTSSyntax {

	public static final String CMD_ACTION = "ACTION";	
	public static final String CMD_CLEAN = "CLEANUP";
	public static final String CMD_COMM = "COMMENT";
	public static final String CMD_COMP = "COMPARE";
	public static final String CMD_COPY = "COPY";
	public static final String CMD_DEL = "DELETE";
	public static final String CMD_DIS = "DISABLE";
	public static final String CMD_ENDLOOP = "ENDLOOP";
	public static final String CMD_ENDWHILE = "ENDWHILE";
	public static final String CMD_EXISTS = "EXISTS";
	public static final String CMD_HMB = "HANDLEMESSAGEBOX";
	public static final String CMD_KB = "KEYBOARD";	
	public static final String CMD_LAUNCH = "LAUNCH";
	public static final String CMD_LOOP = "LOOP";
	public static final String CMD_MESS = "MESSAGE";
	public static final String CMD_QUEST = "QUESTION";
	public static final String CMD_READ = "READ";
	public static final String CMD_START = "START";
	public static final String CMD_TEST = "TEST";
	public static final String CMD_WAIT = "WAIT";
	public static final String CMD_WEX = "WINDOWEXISTS";
	public static final String CMD_WHILE = "WHILE";
	
	// abstrakte typen graph. Elemente
	public static final String TYPE_BUTTON = "BUTTON";
	public static final String TYPE_CHECKBOX = "CHECKBOX";
	public static final String TYPE_COMBOBOX = "COMBOBOX";
	public static final String TYPE_COMPONENT = "COMPONENT";
	public static final String TYPE_SPINNER = "SPINNER";
	public static final String TYPE_EDITBOX = "EDITBOX";
	public static final String TYPE_LABEL = "LABEL";
	public static final String TYPE_LIST = "LIST";
	public static final String TYPE_MENU = "MENU";
	public static final String TYPE_RADIOBUTTON = "RADIOBUTTON";
	public static final String TYPE_TABFOLDER = "TABFOLDER";
	public static final String TYPE_TABLE = "TABLE";
	public static final String TYPE_TABLECELL = "TABLECELL";
	public static final String TYPE_TREE = "TREE";
	public static final String TYPE_TREECELL = "TREECELL";
	public static final String TYPE_WINDOW = "WINDOW";
	
	public static final String DEF_MAIN = "MAIN"; // variablenname fr den Hauptfenstertitel
	
	// Konstanten fr das TEST Kommando
	//
	public static final String TEST_ENABLESTATE = "ENABLESTATE";
	public static final String TEST_FOCUSSTATE = "FOCUSSTATE";
	public static final String TEST_VISIBLESTATE = "VISIBLESTATE";
	public static final String TEST_CHECKSTATE = "CHECKSTATE";
	
	public static final String TEST_TEXT = "TEXT";
	public static final String TEST_NUM = "NUM";
	public static final String TEST_ITEMCOUNT = "ITEMCOUNT";
	public static final String TEST_PROPERTY = "PROPERTY";
	
	// Konstanten fr das READ Kommando
	//
	public static final String READ_TEXT = "TEXT";
	public static final String READ_NUM = "NUM";
	public static final String READ_ENABLESTATE = "ENABLESTATE";
	public static final String READ_FOCUSSTATE = "FOCUSSTATE";
	public static final String READ_VISIBLESTATE = "VISIBLESTATE";
	public static final String READ_PROPERTY = "PROPERTY";
	public static final String READ_CHECKSTATE = "CHECKSTATE";
	public static final String READ_ITEMCOUNT = "ITEMCOUNT";
	
	// Konstanten fr das COMPARE Kommando
	//
	public static final String COMPARE_EQ  = "EQ";
	public static final String COMPARE_GRT = "GRT";
	public static final String COMPARE_GEQ = "GEQ";
	public static final String COMPARE_LSS = "LSS";
	public static final String COMPARE_LEQ = "LEQ";
	public static final String COMPARE_NEQ = "NEQ";
	public static final String COMPARE_TOL = "TOL";
	public static final String COMPARE_VAR = "VAR";
	public static final String COMPARE_VAL = "VAL";
	public static final String COMPARE_STR = "STR";
	public static final String COMPARE_NUM = "NUM";
	public static final String COMPARE_BOOL = "BOOL";
	public static final String COMPARE_TRUE = "TRUE";
	public static final String COMPARE_FALSE = "FALSE";
	
	// Konstanten fr alle Fileoperation Kommandos
	// verzeichnisnamen
	public static final String FILEOP_ABS = "ABS";
	public static final String FILEOP_TGT = "TGT";
	public static final String FILEOP_REF = "REF";
	public static final String FILEOP_BIN = "BIN";
	public static final String FILEOP_ENV = "ENV";
	public static final String FILEOP_LOG = "LOG";
	
	// Konstanten fr das COPY Kommando
	public static final String COPY_FORCE = "FORCE";
	public static final String COPY_IFSRCEXISTS = "IFSRCEXISTS";
	
	// Konstanten fr das DELETE Kommando
	public static final String DELETE_FORCE = "FORCE";
	public static final String DELETE_IFEXISTS = "IFEXISTS";
	
	// Konstanten fr EXISTS Kommando
	public static final String EXISTS_DIRECTORY = "DIRECTORY";
	
	// Konstanten fr das WINDOWEXISTS Kommando
	public static final String WEX_YES = "YES";
	public static final String WEX_NO = "NO";
	
	// Konstanten fr Question Kommando
	public static final String QUESTION_YES = "YES";
	public static final String QUESTION_NO = "NO";
	
	// Konstanten fr das LAUNCH Kommando
	public static final String LAUNCH_FOREVER = "FOREVER";
	public static final String LAUNCH_TIME = "TIME";
	public static final String LAUNCH_NOWAIT = "NOWAIT";
	
	public static final String ACTION_CLOSE = "CLOSE";
	public static final String ACTION_MAXIMIZE = "MAXIMIZE";
	public static final String ACTION_MINIMIZE = "MINIMIZE";
	public static final String ACTION_NORMALIZE = "NORMALIZE";
	public static final String ACTION_CLICK = "CLICK";
	public static final String ACTION_PRESSKEY = "PRESSKEY";
	public static final String ACTION_PROPERTY = "PROPERTY";
	public static final String ACTION_EDIT = "EDIT";
	public static final String ACTION_SET = "SET";
	public static final String ACTION_CHECK = "CHECK";
	public static final String ACTION_UNCHECK = "UNCHECK";
	public static final String ACTION_SELECT = "SELECT";
	public static final String ACTION_ADDSELECT = "ADDSELECT";
	public static final String ACTION_LEFT = "LEFT";
	public static final String ACTION_RIGHT = "RIGHT";
	public static final String ACTION_DESELECT = "DESELECT";
	public static final String ACTION_SUBITEM = "SUBITEM";
	public static final String ACTION_SHIFT = "SHIFT";
	public static final String ACTION_ALT = "ALT";
	public static final String ACTION_CTRL = "CTRL";
}
