package atosj.model.pack;

import atosj.editors.AtosJCloneable;
import atosj.model.script.HTSScript;

/**
 * Stellt ein Element eines Pakets dar. Beinhaltet ein <code>HTSScript</code>
 * und die Position des Skripts im Paket.
 * @author Nicos Tegos
 */
public class PackageElement implements AtosJCloneable
{
	private int index;
	private HTSScript script;
	
	/**
	 * Erstellt ein neues Paketelement.
	 * @param script Das Skript.
	 * @param index Der Index des Skripts im Paket.
	 */
	public PackageElement(HTSScript script, int index) {
		this.script = script;
		this.index = index;
	}

	/** Liefert den Index des Skripts im Paket.
	 * @see #setIndex(int) */
	public int getIndex() {
		return index;
	}

	/** 
	 * Setzt den Index des Skripts im Paket.
	 * @param index Der neue Index.
	 * @see #getIndex()
	 * */
	public void setIndex(int index) {
		this.index = index;
	}

	/** Liefert das enthaltene Skript */
	public HTSScript getScript() {
		return script;
	}
	
	public Object clone() {
		return new PackageElement( getScript(), getIndex() );
	}
}
