package atosj.model.recorder;

import java.rmi.Remote;
import java.rmi.RemoteException;

import atosj.app.TestObject;
import atosj.model.hts.command.HTSCommand;

/**
 * Diese Interface empfngt zur Laufzeit des Testobjekts durch Capture
 * generierte TEST und ACTION Kommandos und leitet sie weiter. Eine
 * Instanz dieses Interfaces wartet im ATOSj Prozess auf Kommandos die
 * im Prozess des Testobjektes aufgenommen wurden.
 * @author Nicos Tegos
 * @see atosj.model.recorder.IScriptRecorder
 */
public interface IHTSCommandReceiver extends Remote {

	/** Liefert das Testobjekt. */
	public TestObject getTestObject() throws RemoteException;
	/** 
	 * Der Partner im Prozess des Testobjekts sendet ein gecapturetes Kommando.
	 * @param command Das gecapturete Kommando.
	 */
	public void publishHTSCommand(HTSCommand command) throws RemoteException;
	/** Informiert darber das der Prozess des Testobjekts beendet wurde. */
	public void clientShutdown() throws RemoteException;
	
	public void debugMessage(String debugString) throws RemoteException;

}
