/*
 * Created on 12.06.2006
 */
package atosj.model.recorder;

import java.rmi.Remote;
import java.rmi.RemoteException;

import atosj.app.TestObject;
import atosj.exception.AtosJException;

/**
 * Diese Klasse startet das Testobjekt und initialisiert den Capture-Mechanismus.
 * Aufgezeichnete Kommandos werden an den Partner im ATOSj Prozess bermittelt.
 * @author Nicos Tegos
 * @see atosj.model.recorder.IHTSCommandReceiver
 */
public interface IScriptRecorder extends Remote {
	/**
	 * Startet das Capturing.
	 * @param testee Das zu startende Testobjekt.
	 * @throws AtosJException Bei einem Fehler z.B. 
	 * wenn die main-Klasse des Testobjektes nicht gefunden
	 * werden konnte.
	 */
	void start(TestObject testee) throws AtosJException, RemoteException;
}
