/*
 * Created on 12.06.2006
 */
package atosj.model.urf;

import java.rmi.Remote;
import java.rmi.RemoteException;

import atosj.app.TestObject;
import atosj.exception.AtosJException;

/**
 * Ein <code>IURFGenerator</code> berwacht das ffnen von Fenstern 
 * im Testobjekt und ermittelt die eindeutigen IDs zu den Elementen 
 * in diesen Fenstern. Er wird von einem <code>IURFReceiver</code> gestartet,
 * und liefert diesem dann die aufgezeichneten IDs.
 * @author Nicos Tegos
 * @see atosj.component.ComponentId
 * @see atosj.model.urf.IURFReceiver
 */
public interface IURFGenerator extends Remote 
{
	/**
	 * Startet die ID Generierung.
	 * @param testee Das zu startende Testobjekt.
	 * @throws AtosJException Bei einem Fehler z.B. 
	 * wenn die main-Klasse des Testobjektes nicht gefunden
	 * werden konnte.
	 */
	void start(TestObject testee) throws AtosJException, RemoteException;
}
