package atosj.model.urf;

import java.rmi.Remote;
import java.rmi.RemoteException;
import java.util.Vector;

import atosj.app.TestObject;

/**
 * Empfngt IDs zu den Components des Testobjekts.
 * Residiert im ATOSj Prozess.
 * 
 * @author Nicos Tegos
 */
public interface IURFReceiver extends Remote {
	
	/** Liefert das Testobjekt */
	public TestObject getTestObject() throws RemoteException;
	/**
	 * Der Kommunikationspartner im Testobjekt Prozess bermittelt
	 * generierte IDs.
	 * @param ids Vector(ComponentID) Die generierten IDs.
	 * @see atosj.component.ComponentId
	 **/
	public void publishIds(Vector ids) throws RemoteException;
	/** Der Kommunikationspartner informiert ber das Beenden des Testobjekts. */
	public void clientShutdown() throws RemoteException;

}
