/*
 * Created on 05.09.2005
 */
package atosj.rmi;

import java.rmi.Remote;
import java.rmi.RemoteException;

import atosj.app.TestObject;

/**
 * @author Nicos Tegos
 */
public interface IHTSPlayer extends Remote
{
	/**
	 * Zerstrt den Remote-Prozess des Testobjekts und lscht alle Variablen.
	 */
	void cleanup() throws RemoteException;

	/**
	 * Liefert einen Variablenwert.
	 * @param varName Der Variablenname.
	 * @return Den Wert der Variablen oder <code>null</code>, wenn nicht initialisiert.
	 */
	Object getVar(String varName) throws RemoteException;

	/**
	 * Setzt den Wert einer Variable.
	 * @param varName Der Variablenname.
	 * @param value Der Wert fr die Variable.
	 */
	void setVar(String varName, Object value) throws RemoteException;

	/** Liefert das Testobjekt. */
	TestObject getTestObject() throws RemoteException;
}
