/*
 * Created on 12.01.2006
 */
package atosj.util;

import org.eclipse.jface.resource.ImageDescriptor;
import org.eclipse.swt.graphics.ImageData;

import atosj.app.AtosJApp;

/**
 * Liefert Bilder fr JFace Actions.
 * @author Nicos Tegos
 */
public class DefaultImageDescriptor extends ImageDescriptor{
	private String imageName;
	
	/**
	 * Erstellt einen neuen ImageDescriptor fr ein Bild.
	 * @param imageName Der Dateiname des Bildes, siehe IMG_* Konstanten
	 * aus der Klasse atosj.app.AtosJApp.
	 */
	public DefaultImageDescriptor(String imageName) {
		this.imageName = imageName;
	}
	
	/**
	 * Leitet weiter an die Methode <code>getImage(imageName)</code> 
	 * aus der Klasse atosj.app.AtosJApp.
	 * @see AtosJApp#getImage(String)
	 */
	public ImageData getImageData() {
		return AtosJApp.getInstance().getImage(imageName).getImageData();
	}

}
