package atosj.util.swteventmonitor;
import java.util.EventListener;

import org.eclipse.swt.widgets.Shell;

/**
 * Dieser Listener wird informiert ber das ffnen und Schlieen
 * von Fenstern in einem SWT-Testobjekt.
 * @author Volker Janetschek
 */
public interface TopLevelWindowListener extends EventListener {
	
	/** 
	 * Informiert, dass ein Fenster im Testobjekt zum ersten Mal aktiviert wurde.
	 * @param shell Das geffnete Fenster.
	 */
	public void newTopLevelWindowActivated(Shell shell);
	
	/** 
	 * Informiert, dass ein Fenster im Testobjekt geschlossen (disposed) wurde.
	 * @param shell Das geschlossene Fenster.
	 */
	public void topLevelWindowDisposed(Shell shell);

}
