/*
 * Created on 16.11.2005
 */
package sampleapp;

import java.util.Vector;

import org.eclipse.jface.action.Action;
import org.eclipse.jface.action.MenuManager;
import org.eclipse.jface.action.Separator;
import org.eclipse.jface.action.ToolBarManager;
import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.jface.viewers.ArrayContentProvider;
import org.eclipse.jface.viewers.CellEditor;
import org.eclipse.jface.viewers.ComboViewer;
import org.eclipse.jface.viewers.ICellModifier;
import org.eclipse.jface.viewers.ILabelProviderListener;
import org.eclipse.jface.viewers.ITableLabelProvider;
import org.eclipse.jface.viewers.ITreeContentProvider;
import org.eclipse.jface.viewers.ListViewer;
import org.eclipse.jface.viewers.StructuredSelection;
import org.eclipse.jface.viewers.TableViewer;
import org.eclipse.jface.viewers.TextCellEditor;
import org.eclipse.jface.viewers.TreeViewer;
import org.eclipse.jface.viewers.Viewer;
import org.eclipse.jface.window.ApplicationWindow;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.TabFolder;
import org.eclipse.swt.widgets.TabItem;
import org.eclipse.swt.widgets.Table;
import org.eclipse.swt.widgets.TableColumn;
import org.eclipse.swt.widgets.TableItem;
import org.eclipse.swt.widgets.Text;
import org.eclipse.swt.widgets.TreeItem;

import sampleapp.custom.DateWidgetWithYear;

class TableElement 
{
	String termin = "";
	String berater = "";
	
	public TableElement() {
	}
	
	public TableElement(String termin, String berater) {
		this.termin = termin;
		this.berater = berater;
	}
	
	public String getBerater() {
		return berater;
	}
	public void setBerater(String berater) {
		this.berater = berater;
	}
	public String getTermin() {
		return termin;
	}
	public void setTermin(String termin) {
		this.termin = termin;
	}
}

class TreeParent extends TreeChild{
	
	private Vector children = new Vector(); // Vector<TreeChild>
	TreeParent(String name, TreeChild[] chil) {
		super(name);
		for(int i = 0; i < chil.length; ++i)
		{
			chil[i].setParent(this);
			children.add(chil[i]);
		}
	}
	
	public Object[] getChildren() {
		return children.toArray();
	}
}

class TreeChild {
	private String name;
	private TreeParent parent = null;
	public TreeChild(String name) {
		this.name = name;
	}
	
	public String toString() {
		return name;
	}
	
	public void setName(String name) {
		this.name = name;
	}
	
	public void setParent(TreeParent parent) {
		this.parent = parent;
	}
	
	public TreeParent getParent() {
		return parent;
	}
}

/**
 * @author Nicos Tegos
 */
public class SWTSampleApp extends ApplicationWindow 
{
	public static final String ATOSJ_COMPONENT_NAME_KEY = "ATOSJ_COMPONENT_NAME_KEY";
	
	private Vector termine = new Vector();
	
	public SWTSampleApp() 
	{
		super(null);
		
		setBlockOnOpen(true);
		addMenuBar();
		addToolBar(SWT.FLAT);
	}

	/* (non-Javadoc)
	 * @see org.eclipse.jface.window.Window#createContents(org.eclipse.swt.widgets.Composite)
	 */
	protected Control createContents(Composite parent) 
	{
		TabFolder tf = new TabFolder(parent, SWT.NULL);
		tf.setData(ATOSJ_COMPONENT_NAME_KEY, "tabfolder");
		
		TabItem tab0 = new TabItem(tf, SWT.NULL);
		tab0.setText("Einfache Elemente");
		Composite tab0Area = new Composite(tf, SWT.NULL);
		tab0Area.setLayout( new GridLayout(2, false) );
		tab0.setControl(tab0Area);
		
		Label lbl = new Label(tab0Area, SWT.NULL);
		lbl.setText("Name:");
		Text nameTxt = new Text(tab0Area, SWT.BORDER);
		nameTxt.setText("Namen eintragen");
		nameTxt.setLayoutData( new GridData(GridData.FILL_HORIZONTAL) );
		nameTxt.setData(ATOSJ_COMPONENT_NAME_KEY, "name");
		lbl = new Label(tab0Area, SWT.NULL);
		lbl.setText("Anschrift:");
		lbl.setLayoutData( new GridData(GridData.VERTICAL_ALIGN_BEGINNING) );
		Text addressTxt = new Text(tab0Area, SWT.BORDER | SWT.MULTI | SWT.WRAP | SWT.V_SCROLL);
		GridData gd = new GridData(GridData.FILL_HORIZONTAL);
		gd.heightHint = 100;
		addressTxt.setLayoutData(gd);
		addressTxt.setData(ATOSJ_COMPONENT_NAME_KEY, "address");
		
		lbl = new Label(tab0Area, SWT.NULL);
		lbl.setText("Beruf:");
		ComboViewer jobCV = new ComboViewer(tab0Area, SWT.BORDER);
		jobCV.setContentProvider( new ArrayContentProvider() );
		jobCV.setInput( new String[] {"Grtner", "Lehrer", "Optiker", "Schornsteinfeger"} );
		jobCV.getCombo().setLayoutData( new GridData(GridData.FILL_HORIZONTAL) );
		jobCV.getCombo().setData(ATOSJ_COMPONENT_NAME_KEY, "job");
		
		lbl = new Label(tab0Area, SWT.NULL);
		lbl.setText("Arbeitssuchend:");
		Button unemployedChk = new Button(tab0Area, SWT.CHECK);
		unemployedChk.setData(ATOSJ_COMPONENT_NAME_KEY, "unemployed");
		
		Group taxArea = new Group(tab0Area, SWT.NULL);
		taxArea.setText("Steuerklasse");
		gd = new GridData(GridData.FILL_HORIZONTAL);
		gd.horizontalSpan = 2;
		taxArea.setLayoutData(gd);
		taxArea.setLayout( new GridLayout(3, false) );
		Button c1 = new Button(taxArea, SWT.RADIO);
		c1.setText("I");
		Button c2 = new Button(taxArea, SWT.RADIO);
		c2.setText("II");
		Button c3 = new Button(taxArea, SWT.RADIO);
		c3.setText("III");
		
		lbl = new Label(tab0Area, SWT.NULL);
		lbl.setText("Stellen:");
		lbl.setLayoutData( new GridData(GridData.VERTICAL_ALIGN_BEGINNING) );
		ListViewer listLV = new ListViewer(tab0Area, SWT.BORDER|SWT.MULTI);
		listLV.getList().setLayoutData( new GridData(GridData.FILL_HORIZONTAL) );
		listLV.setContentProvider( new ArrayContentProvider() );
		listLV.setInput( new String[] {"Pflanzen Klle - Baumschule", "Grtnerei Meier - Pflanzenaufzucht", "TOOM - Zimmerplanzen"} );
		listLV.getList().setData(ATOSJ_COMPONENT_NAME_KEY, "list");
		// MessageBox bei Doppelclick auf liste
		listLV.getList().addMouseListener( new MouseAdapter() {
			public void mouseDoubleClick(MouseEvent arg0) {
				MessageDialog.openInformation(null, "Doppelclick", "Die Liste wurde doppelt angeclickt.");
			}
		});
		Button longBtn = new Button(tab0Area, SWT.PUSH);
		longBtn.setText("Berechne");
		longBtn.addSelectionListener( new SelectionAdapter() {
			public void widgetSelected(SelectionEvent arg0) {
				System.out.println("Berechne gedrckt");
				for(int i = 0; i < 500000; ++i)
				{
					//System.out.println("longwinding operation in progress...");
					double r = i;
					r /= 77 + r * 1.4 - 99.33;
					String x = "Ich bin ein String " + r;
				}
			}
		});
		
		TabItem tab1 = new TabItem(tf, SWT.NULL);
		tab1.setText("Tabelle");
		Composite tab1Area = new Composite(tf, SWT.NULL);
		tab1Area.setLayout( new GridLayout(2, false) );
		tab1.setControl(tab1Area);
		
		final TableViewer terminTV = new TableViewer(tab1Area, SWT.BORDER|SWT.MULTI|SWT.FULL_SELECTION);
		terminTV.setContentProvider( new ArrayContentProvider() );
		terminTV.setLabelProvider( new ITableLabelProvider() {

			public Image getColumnImage(Object arg0, int arg1) {
				return null;
			}

			public String getColumnText(Object element, int col) {
				switch(col)
				{
					case 0: return ((TableElement)element).getTermin();
					case 1: return ((TableElement)element).getBerater();
					default: return "";
				}
			}

			public void addListener(ILabelProviderListener arg0) {
			}

			public void dispose() {
			}

			public boolean isLabelProperty(Object arg0, String arg1) {
				return true;
			}

			public void removeListener(ILabelProviderListener arg0) {
			}
			
		});
		terminTV.setColumnProperties( new String[] {"TERMIN", "BERATER"} );
		terminTV.setCellEditors( new CellEditor[] {new TextCellEditor(terminTV.getTable()), new TextCellEditor(terminTV.getTable())} );
		terminTV.setCellModifier( new ICellModifier() {

			public boolean canModify(Object arg0, String arg1) {
				return true;
			}

			public Object getValue(Object element, String property) {
				if( property.equals("TERMIN") )
					return ((TableElement)element).getTermin();
				if( property.equals("BERATER") )
					return ((TableElement)element).getBerater();
				
				return null;
			}

			public void modify(Object element, String property, Object value) {
				element = ((TableItem)element).getData();
				if( property.equals("TERMIN") )
					((TableElement)element).setTermin( (String)value );
				if( property.equals("BERATER") )
					((TableElement)element).setBerater( (String)value );
				
				terminTV.update(element, new String[] {property} );
			}
			
		});
		
		Table table = terminTV.getTable();
		table.setLayoutData( new GridData(GridData.FILL_BOTH) );
		table.setData(ATOSJ_COMPONENT_NAME_KEY, "table");
		table.setHeaderVisible(true);
		table.setLinesVisible(true);
		
		TableColumn col = new TableColumn(table, SWT.NULL);
		col.setText("Termin");
		col.setWidth(200);
		col = new TableColumn(table, SWT.NULL);
		col.setText("Berater");
		col.setWidth(200);
		
		// input fr die Tabelle
		termine.add( new TableElement("21.05.06 9:00 Uhr", "Gudrun Berater") );
		termine.add( new TableElement("22.06.06", "Frank Vermittler") );
		terminTV.setInput(termine);
		
		Composite terminButtonArea = new Composite(tab1Area, SWT.NULL);
		terminButtonArea.setLayoutData( new GridData(GridData.VERTICAL_ALIGN_BEGINNING) );
		terminButtonArea.setLayout( new GridLayout(1, false) );
		Button addBtn = new Button(terminButtonArea, SWT.FLAT);
		addBtn.setLayoutData( new GridData(GridData.HORIZONTAL_ALIGN_FILL) );
		addBtn.setText("&hinzufgen");
		addBtn.addSelectionListener( new SelectionAdapter() {
			public void widgetSelected(SelectionEvent arg0) {
				TableElement termin = new TableElement("- bitte eintragen -", "- bitte eintragen -"); 
				termine.add(termin);
				terminTV.refresh();
				terminTV.setSelection( new StructuredSelection(termin) );
			}
		});
		Button removeBtn = new Button(terminButtonArea, SWT.FLAT);
		removeBtn.setLayoutData( new GridData(GridData.HORIZONTAL_ALIGN_FILL) );
		removeBtn.setText("lschen");
		removeBtn.addSelectionListener( new SelectionAdapter() {
			public void widgetSelected(SelectionEvent arg0) {
				termine.removeAll( ((StructuredSelection)terminTV.getSelection()).toList() );
				terminTV.refresh();
			}
		});
		
		TabItem tab2 = new TabItem(tf, SWT.NULL);
		tab2.setText("Baum");
		Composite tab2Area = new Composite(tf, SWT.NULL);
		tab2Area.setLayout( new GridLayout(1, false) );
		tab2.setControl(tab2Area);
		
		final TreeViewer treeTV = new TreeViewer(tab2Area, SWT.NULL);
		treeTV.getTree().setLayoutData( new GridData(GridData.FILL_BOTH) );
		treeTV.getTree().setData(ATOSJ_COMPONENT_NAME_KEY, "tree");
		treeTV.setContentProvider( new ITreeContentProvider() {

			public Object[] getChildren(Object arg0) {
				return ((TreeParent)arg0).getChildren();
			}

			public Object getParent(Object arg0) {
				return ((TreeChild)arg0).getParent();
			}

			public boolean hasChildren(Object arg0) {
				return arg0 instanceof TreeParent;
			}

			public Object[] getElements(Object arg0) {
				return ((Vector)arg0).toArray();
			}

			public void dispose() {
			}

			public void inputChanged(Viewer arg0, Object arg1, Object arg2) {
			}
			
		});
		treeTV.setColumnProperties( new String[] {"PROP"} );
		treeTV.setCellEditors( new CellEditor[] {new TextCellEditor(treeTV.getTree())} );
		treeTV.setCellModifier( new ICellModifier() {
			public boolean canModify(Object arg0, String arg1) {
				return true;
			}

			public Object getValue(Object element, String property) {
				if( property.equals("PROP") )
					return ((TreeChild)element).toString();
				
				return null;
			}

			public void modify(Object element, String property, Object value) {
				element = ((TreeItem)element).getData();
				if( property.equals("PROP") )
					((TreeChild)element).setName( (String)value );
				
				treeTV.update(element, new String[] {property} );
			}
		});
		
		// input fr den tree
		Vector treeElements = new Vector();
		treeElements.add( new TreeParent("Fortbildung", new TreeChild[] {new TreeChild("Kaufmannsseminar"), new TreeChild("EDV Schulung"), new TreeChild("Gruppentherapie") }) );
		treeTV.setInput(treeElements);
		
		TabItem tab3 = new TabItem(tf, SWT.NULL);
		tab3.setText("Datum");
		Composite tab3Area = new Composite(tf, SWT.NULL);
		tab3Area.setLayout( new GridLayout(1, false) );
		tab3.setControl(tab3Area);
		DateWidgetWithYear dw = new DateWidgetWithYear(tab3Area, "24.06.1980");
		dw.setData(ATOSJ_COMPONENT_NAME_KEY, "calendar");
		
		return tf;
	}
	
	/* (non-Javadoc)
	 * @see org.eclipse.jface.window.ApplicationWindow#createMenuManager()
	 */
	protected MenuManager createMenuManager() 
	{
		MenuManager menuBar = new MenuManager();
		MenuManager fileMenu = new MenuManager("&Datei");
		fileMenu.add( new Action("&Nachricht") {
			public void run() {
				MessageDialog.openInformation(null, "Nachricht", "Dies ist eine Nachricht.");
			}
		});
		fileMenu.add( new Separator() );
		menuBar.add(fileMenu);
		return menuBar;
	}
	
	protected ToolBarManager createToolBarManager(int style) {
		ToolBarManager toolbarMngr = super.createToolBarManager(style);
		
		toolbarMngr.add( new Action("Beenden\tCTRL+Q") {
			public void run() {
				close();
			}
		});
		return toolbarMngr;
	}
	
	public void create() {
		super.create();
		getShell().setText("SWT SampleApp");
		getShell().setSize(640, 640);
	}
	
	public static void main(String[] args) 
	{
		// Zum Testen fr die Parameterbergabe des Kommandos START
		System.out.println("Argumentanzahl: " + args.length);
		if(args.length ==  2)
		{
			int i = Integer.parseInt(args[0]);
			while(i > 0)
				System.out.println(i-- + ": " + args[1]);
		}
		
		new SWTSampleApp().open();
	}
	
}
