package sampleapp.custom;

import atosj.component.ComponentId;
import atosj.component.ICombobox;
import atosj.component.swt.SWTCombo;
import atosj.component.swt.SWTControl;
import atosj.exception.ComponentException;

public class DateWidgetWrapper extends SWTControl {

	public DateWidgetWrapper(DateWidgetWithYear component, ComponentId id) {
		super(component, id);
	}
	
	private DateWidgetWithYear getDateWidgetWithYear() {
		return (DateWidgetWithYear)getComponent();
	}

	public void setProperty(String property, String value) throws ComponentException {
		if( property.equals("month") )
		{
			try 
			{
				int month = Integer.parseInt(value);
				if(month < 0 || month > 12)
					throw new ComponentException("Der Monat muss im Intervall [0,12] liegen.");
				
				ICombobox monthCombo =  new SWTCombo(getDateWidgetWithYear().getMonthCombo(), getComponentId());
				monthCombo.select(month-1);				
			}
			catch(NumberFormatException e) {
				throw new ComponentException("Der Wert fr den Monat muss eine ganze Zahl sein.");
			}
		}
		else if( property.equals("year") )
		{
			try 
			{
				Integer.parseInt(value);
				ICombobox yearCombo =  new SWTCombo(getDateWidgetWithYear().getYearCombo(), getComponentId());
				yearCombo.select(value);				
			}
			catch(NumberFormatException e) {
				throw new ComponentException("Der Wert fr den Monat muss eine ganze Zahl sein.");
			}
		}
		else
			throw new ComponentException("Die Eigenschaft: " + property + " wird nicht untersttzt.");
	}
	
	public String getProperty(String property) throws ComponentException {
		if( property.equals("month") )
		{
			ICombobox monthCombo = new SWTCombo(getDateWidgetWithYear().getMonthCombo(), getComponentId());
			return monthCombo.getText();				
		}
		else if( property.equals("year") )
		{
			ICombobox yearCombo = new SWTCombo(getDateWidgetWithYear().getYearCombo(), getComponentId());
			return yearCombo.getText();				
		}
		else
			throw new ComponentException("Die Eigenschaft: " + property + " wird nicht untersttzt.");
	}
}
