/*
 * Created on 15.09.2005
 */
package sampleapp.custom;

import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Label;

/**
 * @author tegos
 */
public class WeekWidget extends Composite
{
	private static final String dayNames[] = new String[] { "Mo", "Di", "Mi", "Do", "Fr", "Sa", "So" };
	private Label[] weekDayLbls = new Label[7];
	
	public WeekWidget(Composite parent, boolean showNames) 
	{
		super(parent, SWT.NULL);
		GridLayout gl = new GridLayout(7, true);
		gl.marginHeight = gl.marginWidth = 0;
		setLayout(gl);
		
		for(int i = 0; i < weekDayLbls.length; ++i)
		{
			weekDayLbls[i] = new Label(this, SWT.NULL);
			weekDayLbls[i].setBackground( getDisplay().getSystemColor(SWT.COLOR_GRAY) );
			weekDayLbls[i].setLayoutData( new GridData(GridData.HORIZONTAL_ALIGN_CENTER) );
			
			if(i < 6)
				weekDayLbls[i].setForeground( getDisplay().getSystemColor(SWT.COLOR_WHITE) );
			else
				weekDayLbls[i].setForeground( getDisplay().getSystemColor(SWT.COLOR_RED) );
		}
		
		showNames(showNames);
		setBackground( getDisplay().getSystemColor(SWT.COLOR_GRAY) );
	}
	
	/**
	 *  Standard mit Namen zeigen
	 */
	public WeekWidget(Composite parent) 
	{
		this(parent, true);
	}
	
	public void showNames(boolean show)
	{
		for(int i = 0; i < weekDayLbls.length; ++i)
		{
			if(show)
				weekDayLbls[i].setText( dayNames[i] );
			else
				weekDayLbls[i].setText("");
		}
		
		this.layout();
	}
}
